(*
	Autor 			:	Reini
	letzte Aenderung	: 	20.02.2001

*)



IMPLEMENTATION MODULE HKVerw;

(* -- Importe *)

FROM HKBIMPORTE IMPORT	EinfHK, ExistiertHKID, HUpdateHK, HDeleteHK,
			LHKID,
			VBExistVtrZuHK;
IMPORT String;


	
(* ****************************************************************** *)
	
PROCEDURE AufnehmenHK ( inHK : THK; VAR outMessage : TString) : BOOLEAN;
BEGIN
(* Proze D 3.5.2 *)
(*   Vorbed.: HK nicht in Hilfskraefte
     Nachbed.: neue HK aufgenommen
 *)

     RETURN EinfHK (inHK, outMessage)

END AufnehmenHK;

(* ****************************************************************** *)


(* ****************************************************************** *)


PROCEDURE AendernHK (  inNeuHK : THK; VAR outMessage : TString) : BOOLEAN;
BEGIN
    (* -- hier wird geprft, ob die HKID berhaupt existiert *)

    IF ExistiertHKID(inNeuHK) THEN

	RETURN HUpdateHK (inNeuHK, outMessage)

    ELSE
	
	   (* -- Fehlermeldung HKID existiert nicht *)
	outMessage := String.Create();
	String.Schreibe (outMessage, "HKID existiert nicht!");
	RETURN FALSE
	
    END (* IF *)
END AendernHK;

(* ****************************************************************** *)


(* ****************************************************************** *)


PROCEDURE LoeschenHK ( inHK : THK; VAR outMessage : TString) : BOOLEAN;
BEGIN
   (* -- hier wird geprft, ob die HK berhaupt exisitert *)

 IF ExistiertHKID ( inHK ) THEN

        (* -- hier wird geprft, ob Vertrge existieren*)
        IF NOT VBExistVtrZuHK ( LHKID (inHK)) THEN
        	RETURN HDeleteHK (inHK, outMessage)
        ELSE
        	outMessage := String.Create();
        	String.Schreibe ( outMessage, "Vertraege existieren. HK darf nicht geloescht werden!");
        	RETURN FALSE
	END (* IF NOT VBExistVtrZuHK *)
 ELSE
 	(* -- Fehlermeldung HKID existiert nicht *)
 	outMessage := String.Create();
 	String.Schreibe ( outMessage, "HKID existiert nicht!");
 	RETURN FALSE
 END (*IF*)
END LoeschenHK;

(* ****************************************************************** *)

END HKVerw.