(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: HIDVerwIMPORTE.mod,v $
# $Author: Sopra $
# $Date: 2001/03/10 09:48:30 $
# $Revision: 1.1.1.1 $
# Bemerkungen:
*)
(******************************************************************************)

(* Modul zur Simulation der Importschnittstelle des TS HIDVerwaltung          *)
IMPLEMENTATION MODULE HIDVerwIMPORTE;
  IMPORT VDat;
  FROM String IMPORT TString;

  PROCEDURE ReadLine ( inH: THandle; 
                       VAR inoutString: TString; 
                       VAR inoutM: TString): BOOLEAN;
        (* Liest aus der Datei inH von der aktuellen Position bis zum *)
        (* nchsten EOL oder EOF . Falls dabei ein Fehler auftritt wird*)
        (* false und ein Fehler in inoutM zurckgegeben, sonst true *)
  BEGIN
	RETURN VDat.ReadLineInVDat(inH,inoutString,inoutM);
  END ReadLine;

  PROCEDURE WriteLine( inH : THandle;
                       inS : TString;
                       VAR inoutM : TString) : BOOLEAN;
        (* Schreibt in die Datei inH an die aktuelle Position den String inS *)
        (* gefolgt von einem Zeilen-Ende-Zeichen *)
        (* Falls dabei ein Fehler auftritt, wird false und ein Fehler in*)
        (* inoutM zurckgegeben, sonst true *)
  BEGIN
	RETURN VDat.WriteLineInVDat(inH,inS,inoutM);
  END WriteLine;

  PROCEDURE Eof ( inH : THandle): BOOLEAN;
           (* Prft ob Pos = EOF ist *) 
  BEGIN
	RETURN VDat.EofInVDat( inH ) ;
  END Eof;         

END HIDVerwIMPORTE.
