IMPLEMENTATION MODULE FAendernVtrHKB;

FROM SYSTEM   IMPORT CAST, ADR, ADDRESS;
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen,JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;
FROM args     IMPORT GetArgs, ArgTable;
FROM InOut    IMPORT WriteString,WriteLn,WriteInt;

IMPORT Strings;
IMPORT String;
IMPORT Stringliste;
IMPORT FLadenSysVw;
IMPORT Vtre;
IMPORT Datum;
IMPORT SysDat;
IMPORT WholeStr;
IMPORT DialogLib;

TYPE TActVater   = PROCEDURE();
     TCharString = ARRAY[0..255] OF CHAR;

VAR
  FensterHandle					: ADDRESS;
  VaterFenster					: ADDRESS;
  Vater									: ADDRESS;
  EndeKnopfHandle				: ADDRESS;
  VtrIdMeldTitel				: ADDRESS;
  VtrIdMeld							: ADDRESS;
  PersIdMeldTitel       : ADDRESS;
  PersIdMeld						: ADDRESS;
  KstIdMeldTitel				: ADDRESS;
  KstIdMeld							: ADDRESS;
  WeiterKnopfHandle			: ADDRESS;
  AendernKnopfHandle		: ADDRESS;
  StdZahlTitel					: ADDRESS;
  StdZahlAnzeige  			: ADDRESS;
  TaetigkeitTitel				: ADDRESS;
  TaetigkeitAnzeige     : ADDRESS;
  BegrTitel							: ADDRESS;
  BegrAnzeige           : ADDRESS;
  GueltigBisZeile				: ADDRESS;
  GueltigVonTitel       : ADDRESS;
  GueltigVonAnzeige			: ADDRESS;
  ErstDatTitel					: ADDRESS;
  HkeListeHdle					: ADDRESS;
  Hinweis1 							: ADDRESS;
  VtrListHdle           : ADDRESS;
  (*Felder fr die Ausgabe des gesuchten Vertrages*)
  ErstDatAnzeige				: ADDRESS;
  VtrStrList						: Stringliste.TStringliste;
  globalVtrId_str  			: String.TString;
  globalPersId_str			: String.TString;
  globalKstId_str 			: String.TString;
  Vertrag								: Vtre.TVtr;
(*----------------------------------------------------------------------------------------*)

PROCEDURE StC(inStr : String.TString) : TCharString;
(*Umwandlung von TString nach Arrayof Char = TCharString*)
VAR outcharfeld : TCharString;
BEGIN
 String.Lies(inStr,outcharfeld);
 RETURN outcharfeld;
END StC;

(*----------------------------------------------------------------------------------------*)

PROCEDURE InitMaske();
(*Erzeugt die initiale Ein-Ausgabemaske *)
VAR Titel       : String.TString;

BEGIN
  Titel := String.Create();
  String.Schreibe(Titel,"Abbrechen");
  EndeKnopfHandle := StelleKnopfDar(Titel,FensterHandle,330,450,
                                    CAST(PROC,EndeKnopfCallback));

  String.Schreibe(Titel,"Testknopf");

  WeiterKnopfHandle := StelleKnopfDar(Titel,FensterHandle,470,330,
                                     CAST(PROC,WeiterKnopfCallback));
END InitMaske;

(*----------------------------------------------------------------------------------------*)

PROCEDURE EndeKnopfCallback();
VAR Abfragetext : String.TString;
BEGIN
  EntferneKnopf(EndeKnopfHandle);
  EntferneFenster(FensterHandle);
  Dispose();
END EndeKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowContentOfVtre();
VAR  StrListe : Stringliste.TStringliste;
     s : String.TString;

BEGIN
   s := String.Create();
   VtrStrList := Vtre.GibVtrAlsStringlisteInVtr();

   String.Schreibe(s," VID   PID  KID    Datum");

   VtrListHdle := StelleListeDar(VtrStrList,s,4,FensterHandle,290,160,
   															 CAST(PROC,VtreListeCallback));
   Stringliste.Dispose(VtrStrList);
   String.Dispose(s);
END ShowContentOfVtre;

(*----------------------------------------------------------------------------------------*)

PROCEDURE VtreListeCallback(element : INTEGER);
VAR Titel       : String.TString;
    Text        : String.TString;
    Abfragetext : String.TString;
    HilfString  : String.TString;
    HeuteString : String.TString;
    Heute   		: Datum.TDatum;

BEGIN
  IF VtrIdMeld <> NIL THEN
    EntferneMeldung(VtrIdMeld)
  END;
  Text := String.Create();

  LiesListenelement(VtrListHdle,element,Text);
  (*Die selektierten Daten aus der Darstellung zwischenspeichern *)
  ExtractVtrId (Text,globalVtrId_str,0,5);
  ExtractPersId(Text,globalPersId_str,6,5);
  ExtractKstId (Text,globalKstId_str,12,5);

  EntferneListe(VtrListHdle);

  WeiterKnopfCallback();

END VtreListeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE WeiterKnopfCallback();
										(*----------------LokaleProcedure----------------*)
PROCEDURE AusgabeFormular();
VAR Abfragetext : String.TString;
    Titel				: String.TString;
    Text        : String.TString;
    HilfString  : String.TString;
    HeuteString : String.TString;
    Heute   		: Datum.TDatum;
    GueVonDatum      : Datum.TDatum;
    Zeichenkette: ARRAY[0..255] OF CHAR;
    StdZahl     : CARDINAL;
BEGIN
  HilfString := String.Create();
  Titel      := String.Create();


  String.Schreibe(Titel,"VtrID:");
  VtrIdMeldTitel := StelleMeldungDar(Titel,TRUE,FensterHandle,280,60);
  VtrIdMeld  :=  StelleMeldungDar(globalVtrId_str,FALSE,FensterHandle,330,60);
  String.Dispose(globalVtrId_str);

  String.Schreibe(Titel,"PersID:");
  PersIdMeldTitel := StelleMeldungDar(Titel,FALSE,FensterHandle,60,90);
  PersIdMeld      := StelleMeldungDar(globalPersId_str,FALSE,FensterHandle,120,90);
  String.Dispose(globalPersId_str);

  String.Schreibe(Titel,"KstID:");
  KstIdMeldTitel := StelleMeldungDar(Titel,FALSE,FensterHandle,60,120);
  KstIdMeld      := StelleMeldungDar(globalKstId_str,FALSE,FensterHandle,120,120);
  String.Dispose(globalKstId_str);

  (* Vertrag.Stundenzahl ausgeben *)
  String.Schreibe(Titel,"Anz.Std.: ");
  StdZahlTitel   := StelleMeldungDar(Titel,FALSE,FensterHandle,60,150);
  (*
  Text := String.Create();
  StdZahl        := Vtre.LiesStdzahlinVtr(Vertrag);
  WholeStr.CardToStr(StdZahl,Zeichenkette);
  String.Schreibe(Text,Zeichenkette);
  StdZahlAnzeige := StelleMeldungDar(Text,FALSE,FensterHandle,120,150);
  String.Dispose(Text);
  *)
  (* Vertrag.Taetigkeit ausgeben *)
  String.Schreibe(Titel,"Taetigkeit:");
  TaetigkeitTitel   := StelleMeldungDar(Titel,FALSE,FensterHandle,60,180);

  (*
  Text 							:= Vtre.LiesTaetigktinVtr (Vertrag);
  TaetigkeitAnzeige := StelleMeldungDar(Text,FALSE,FensterHandle,120,180);
  String.Dispose(Text);
  *)
  (* Vertrag.Begruendung ausgeben *)
  String.Schreibe(Titel,"Begruendung: ");
  BegrTitel   := StelleMeldungDar(Titel,FALSE,FensterHandle,60,210);
  (*
  Text 				:= Vtre.LiesBegruendinVtr (Vertrag);
  BegrAnzeige := StelleMeldungDar(Text,FALSE,FensterHandle,120,210);
  String.Dispose(Text);
  *)

  String.Schreibe(Titel,"GueltigVon: ");
  GueltigVonTitel   := StelleMeldungDar(Titel,FALSE,FensterHandle,60,240);

  (*
  GueVonDatum 			:= Vtre.LiesGueltigVoninVtr (Vertrag);
  Text 							:= Datum.DatumAlsString(GueVonDatum);
  GueltigVonAnzeige := StelleMeldungDar(Titel,FALSE,FensterHandle,120,240);
  String.Dispose(Text);
  *)

  String.Schreibe(Titel,"GueltigBis:");
  GueltigBisZeile := StelleZeileDar(Titel,HilfString,10,FensterHandle,60,270);
  (*
  Heute          := SysDat.LiesSystemDatumInSysDat();
  HeuteString    := String.Create();
 	String.Schreibe(HeuteString,StC(Datum.DatumAlsString(Heute)));
  String.Schreibe(Titel,"Erstellungsdatum: ");
  ErstDatTitel   := StelleMeldungDar(Titel,FALSE,FensterHandle,60,300);
  ErstDatAnzeige := StelleMeldungDar(HeuteString,FALSE,FensterHandle,190,300);
  String.Dispose(HeuteString);
  *)

  String.Schreibe(Titel,"(Storno: GueltigBis := GueltigVon || Aendern: GueltigBis vorziehen)");
  Hinweis1 := StelleMeldungDar(Titel,FALSE,FensterHandle,180,400);

  String.Schreibe(Titel,"nderungen bernehmen");
  AendernKnopfHandle := StelleKnopfDar(Titel,FensterHandle,290,350,
  																     CAST(PROC,AendernKnopfCallback));

  String.Dispose(Titel);
END AusgabeFormular;

									(*----------------LokaleProcedure----------------*)

PROCEDURE VertragEinlesen(VAR outVtr : Vtre.TVtr) : BOOLEAN;
VAR Vertrag : Vtre.TVtr;
    VertrID : Vtre.TVtrID;
    success : BOOLEAN;
BEGIN

  (*VertrID := Vtre.StringInVtrID (globalVtrId_str);*)
  (*success := Vtre.SearchVtr( VertrID,Vertrag); *)
  (*  success := Vtre.FirstVtr(Vertrag); *) (*TEST*)
  IF NOT(success) THEN
    WriteString("Einlesen des Vertrages fehlgeschlagen");WriteLn();
  END;
  RETURN(success);
END VertragEinlesen;
								
								 (*-------------Lokale Prozedur ENDE------------------*)

(*Hauptprocedure*)
VAR Text     : String.TString;
    success  : BOOLEAN;
BEGIN
 EntferneKnopf(WeiterKnopfHandle);
 EntferneListe(VtrListHdle);
 (* aus Testzweckken: ---> success := TRUE;  *)

  success := VertragEinlesen(Vertrag);

 IF NOT success THEN
  Text := String.Create();
  String.Schreibe(Text,"Vtr einlesen fehlgeschlagen");
  MeldungAnzeigen(Text);
  String.Dispose(Text);
 END;
 IF success THEN
  AusgabeFormular();
 END;
END WeiterKnopfCallback;

(*---------------------------------------------------------------------------*)

PROCEDURE AendernKnopfCallback();
(* Einlesen von DatumBis aus Formular, anschlieend Datum in Vertrag einschreiben *)


        (*--------------------Lokale Procedure--------------------*)
PROCEDURE TestGueltigBis() : BOOLEAN;
(*Prueft Korrektheit des Datumformates von SGueltigBis*)
VAR errmsg  : String.TString;
    s       : String.TString;
BEGIN
  errmsg := NIL;
  IF DialogLib.DatumKorrekt(sGueltigBis_g,errmsg) THEN
     WriteString(StC(errmsg));
     IF errmsg <> NIL THEN
       String.Dispose(errmsg);
       errmsg := NIL;
     END;
     RETURN TRUE;
  ELSE
     s := String.Create();
     String.Schreibe(s,"GueltigBis: ");
     String.Anhaengen(errmsg,s);
     MeldungAnzeigen(s);
     String.Dispose(s);
     RETURN FALSE;
  END;
  IF errmsg <> NIL THEN
   String.Dispose(errmsg);
   errmsg := NIL;
  END;
END TestGueltigBis;
        (*---------------------------------------------------------*)

(* Hauptprocedure AendernKnopfCallback *)
VAR sGueltigBis_g	: String.TString;
    ok 						: BOOLEAN;
    BisDatum    	: Datum.TDatum;
    errmsg      	: String.TString;
    meldung     	: String.TString;
    okMeldungHdle	: ADDRESS;
BEGIN
  errmsg := NIL;
  ok := FALSE;
  sGueltigBis_g := String.Create();
  (*!!!!!!!!!!!!!!!!TEST************) ok := TRUE;
  LiesZeile(GueltigBisZeile,sGueltigBis_g);
  (*Teste Datumformat *)
  ok := TestGueltigBis();

  (*Konvertierung von Zeichenkette ber String  nach Datum *)
(*
  IF ok THEN
    BisDatum := Datum.CreateDatum();
    ok := Datum.DatumVonString (sGueltigBis_g,BisDatum,errmsg);
    WriteString(StC(errmsg));WriteLn();
    IF errmsg <> NIL THEN
     String.Dispose(errmsg);
     errmsg := NIL;
    IF sGueltiBis_g <> NIL THEN
     String.Dispose(sGueltigBis);
     sGueltigBis := FALSE;
    END;
  END;
 *)
  (* Vertrag.GueltigBis setzen *)
(*
  IF ok THEN
    Vtre.SetzeGueltigBisinVtr(Vertrag,BisDatum);
  END;
*)
  (* Aenderung im Ordner Vtre durchfhren *)
(*
  IF ok THEN
    ok := Vtre.AendernVtr (Vertrag,errmsg);
    WriteString(StC(errmsg));
    IF errmsg <> NIL THEN
     String.Dispose(errmsg);
     errmsg := NIL;
    END;
  END;
*)
  (* ok ==> Meldung ausgeben *)
(*
  IF ok THEN
    meldung := String.Create();
    String.Schreibe(meldung,"nderung/Stornierung gelungen");
    okMeldungHdle := StelleMeldungDar(meldung,TRUE,FensterHandle,280,360);
  END;
*)
  (* NOT ok ==> Fehlermeldung ausgeben *)

  IF NOT ok THEN
    meldung := String.Create();
    String.Schreibe(meldung,"Datum konnte nicht eingefuegt werden");
    MeldungAnzeigen(meldung);
  END;

  EntferneKnopf(AendernKnopfHandle);

END AendernKnopfCallback;

(*----------------------------------------------------------------------------*)

PROCEDURE Create(inFunct : ADDRESS);
VAR Titel : String.TString;
BEGIN
  Vertrag    := NIL;
  VtrStrList := NIL;
  VtrIdMeld  := NIL;
  globalVtrId_str  := String.Create();
  globalPersId_str := String.Create();
  globalKstId_str  := String.Create();
  Vater := inFunct;
  Titel := String.Create();
  String.Schreibe(Titel,"V e r t r a g   S t o r n i e r e n  |  A e n d e r n");
  FensterHandle :=  NeuesFenster( Titel,140,80,500,800);
  InitMaske();
  ShowContentOfVtre();
END Create;

(*------------------------------------------------------------------------------*)

PROCEDURE Dispose();
VAR AktiviereVater : TActVater;
BEGIN
  IF Vertrag <> NIL THEN
   Vtre.DisposeVtr(Vertrag);
   Vertrag    := NIL;
  END;
  VtrStrList := NIL;
  VtrIdMeld  := NIL;
  VtrStrList := NIL;
  String.Dispose(globalVtrId_str);
  String.Dispose(globalPersId_str);
  String.Dispose(globalKstId_str);

  WriteString("SysVwLaden.Dispose");WriteLn;

  EntferneKnopf(EndeKnopfHandle);
  EntferneFenster(FensterHandle);
  AktiviereVater := CAST(TActVater,Vater);
  AktiviereVater();
END Dispose;
(*------------------------------------------------------------------------------*)

PROCEDURE ExtractVtrId(inQuelle : String.TString; VAR inoutZiel : String.TString;
   								     inStartPos,inAnzahl : CARDINAL);
(* Auslesen von anzahl Zeichen ab start von inQuelle, dannRckgabe via outZiel*)
VAR selString : String.TString;
BEGIN
  selString := String.Create();
  String.Auslesen (inQuelle,inStartPos,inAnzahl,selString);
  WriteString(StC(selString));WriteLn();
  String.Equalize(inoutZiel,selString);
  WriteString(StC(inoutZiel));WriteLn();
  String.Dispose(selString);
END ExtractVtrId;

(*---------------------------------------------------------------------------------*)

PROCEDURE ExtractPersId(inQuelle : String.TString; VAR inoutZiel : String.TString;
   								      inStartPos,inAnzahl : CARDINAL);
(* Auslesen von anzahl Zeichen ab start von inQuelle, dannRckgabe via outZiel*)
VAR selString : String.TString;
BEGIN
  selString := String.Create();
  String.Auslesen (inQuelle,inStartPos,inAnzahl,selString);
  String.Equalize(inoutZiel,selString);
  String.Dispose(selString);
END ExtractPersId;
(*----------------------------------------------------------------------------------*)


PROCEDURE ExtractKstId(inQuelle : String.TString; VAR inoutZiel : String.TString;
   								     inStartPos,inAnzahl : CARDINAL);
(* Auslesen von anzahl Zeichen ab start von inQuelle, dannRckgabe via inoutZiel*)
VAR selString : String.TString;
BEGIN
  selString := String.Create();
  String.Auslesen (inQuelle,inStartPos,inAnzahl,selString);
  String.Equalize(inoutZiel,selString);
  String.Dispose(selString);
END ExtractKstId;
(*----------------------------------------------------------------------------------*)

END FAendernVtrHKB.