(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

IMPLEMENTATION MODULE FBuchenKT;

JZ

V 0.0   23.1.01  21:40
V 0.1   24.1.01  21:40


*)
(******************************************************************************)

IMPLEMENTATION MODULE FBuchenKT;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM InOut IMPORT WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;



(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
(*
FROM Datum 	IMPORT 	TDatum, TTag, TMonat, TJahr, TStag, CreateDatum;
FROM Vtre	IMPORT 	TVtrID, TVtr;

FROM Buen IMPORT TBu, TBuID, CreateBu, DisposeBu, DuplicateBu, IsEqualBu,
		EqualizeBu, LiesBuIDinBu, LiesKstIDinBu, SetzeKstIDinBu,
		LiesVtrIDinBu, SetzeVtrIDinBu, LiesBetraginBu,
		SetzeBetraginBu, LiesGebuchtAminBu, SetzeGebuchtAminBu,
		LiesStorniertAminBu, SetzeStorniertAminBu, IstStorniertinBu,
		LiesBuchungsArtinBu, SetzeBuchungsArtinBu, BuIDAlsString,
		StringInBuID, PruefeBuID, ExistiertBuIDBu;


FROM Ksten IMPORT TKstID, TKst, CreateKst, SetzeKIDinKst, LiesKIDinKst,
 		SetzeEingAminKst, LiesEingAminKst, SetzeGesperrtAminKst,
 		LiesGesperrtAminKst,IstGesperrtAminKst,SetzeLiquidAminKst, 	
		LiesLiquidAminKst, IstLiquidiertAminKst, SetzeNameinKst,
		LiesNameinKst, SetzeJahrinKst,LiesJahrinKst, SetzeKontinginKst,
		LiesKontinginKst, SetzeAequivinKst, LiesAequivinKst,
		ExistKst, KstIDAlsString, StringInKstID, PruefeKstID,
		GibKstenAlsStringlisteInKsten, SearchKstZuKID;


FROM Konden IMPORT TKond, CreateVertragsKondition, CreateWeihnachtsKondition,
		CreateTarifkondition, DisposeKond, SetzeGueltVoninKond,
		LiesGueltVoninKond, SetzeGueltBisinKond, LiesGueltBisinKond,
		SetzeBHDinVKond, LiesBHDinVKond, SetzeSOGinVKond,
		LiesSOGinVKond, SetzeStdSinTKond, LiesStdSinTKond,
		SetzeSTaginWKond, LiesSTaginWKond, SetzeBemMonatinWKond,
		LiesBemMonatinWKond, HoleGueltigeVKond, HoleGueltigeTKond,
		HoleGueltigeWKond;


FROM PSB IMPORT	SperrenKst, EntsperrenKst, EinrichtenKst, BearbeitenBuchenKst,
                BearbeitenAendernKst, TKondGeprueftEinf, WKondGeprueftEinf, VKondGeprueftEinf;
*)





(* ACHTUNG : Das Programm entfernt keine erzeugten Strings und
** Stringlisten. Die X-Grafik-Bibliothek kopiert alle Strings, so
** dass diese nach Erzeugung der Fenster geloescht werden koennten.
** Das Schliessen eines Fensters ueber die Window s-Menue-Leiste wird
** von der X-Grafik-Bibliothek nicht erkannt und ist verboten.
*)

  TYPE 	TFBuchenKstDS = RECORD
		           WinHdle : ADDRESS;
		           BuchenKnopfHdle,
			   LoeschenKnopfHdle,
			   WGKnopfHdle,
			   GehaltKnopfHdle,
			   AbschlussKnopfHdle,
			   SonstigesKnopfHdle, BArtListeKnopfHdle, BArtListenHdle,
			   AbbrechenKnopfHdle:ADDRESS;  		
			   KstIDHdle,
			   NameHdle,
			   JahrHdle,
			   GesperrtAmHdle,
			   LiquidiertAmHdle,
			   BuchungsArtHdle,
			   BetragHdle : ADDRESS;
(*  	      		   Kst: TKst;
			   KstID: TKstID;    *)
  	   		   KstIDString: String.TString;
  	      		   BArtStringListe: Stringliste.TStringliste;
  	      		   BuchungsArtString: String.TString;
  	      		   BuchungsArtAktiv: BOOLEAN;
  	      		 END;	
        TPFBuchenKst = POINTER TO TFBuchenKstDS;



(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfY1Pos=INT(185);
    KnopfY2Pos=INT(250);
    BuchenKnopfXPos=INT(40);
    LoeschenKnopfXPos=INT(160);
    AbbrechenKnopfXPos=INT(340);
    AbschlussKnopfXPos=INT(120);
    GehaltKnopfXPos=INT(200);
    SonstigesKnopfXPos=INT(260);
    WGKnopfXPos=INT(340);
    BArtListeKnopfXPos=INT(250);
  VAR
    I: CARDINAL;
    KnopfText: String.TString;

    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFBuchenKst;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.AktivFAnlegen Begin"); WriteLn; END;

    (* Erzeuge den Fensterinhalt *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);

    InitEinAusgabeFelder();

    KnopfText := String.Create();

(*
    String.Schreibe(KnopfText,"Abschluss");
    ichSelbst^.AbschlussKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, AbschlussKnopfXPos, KnopfY1Pos, CAST(PROC,AbschlussKnopfCallback));
    KnopfText := String.Create();
    String.Schreibe(KnopfText,"Gehalt");
    ichSelbst^.GehaltKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, GehaltKnopfXPos, KnopfY1Pos, CAST(PROC,GehaltKnopfCallback));
    KnopfText := String.Create();
    String.Schreibe(KnopfText,"Sonstiges");
    ichSelbst^.SonstigesKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, SonstigesKnopfXPos, KnopfY1Pos, CAST(PROC,SonstigesKnopfCallback));
    KnopfText := String.Create();
    String.Schreibe(KnopfText,"Weihnachtsgeld");
    ichSelbst^.WGKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, WGKnopfXPos, KnopfY1Pos, CAST(PROC,WGKnopfCallback));
*)

    String.Schreibe(KnopfText,"");
    ichSelbst^.BArtListeKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, BArtListeKnopfXPos, KnopfY1Pos, CAST(PROC,BArtListeKnopfCallback));

	
    KnopfText := String.Create();
    String.Schreibe(KnopfText,"Buchen");
    ichSelbst^.BuchenKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, BuchenKnopfXPos, KnopfY2Pos, CAST(PROC,BuchenKnopfCallback));

    String.Schreibe(KnopfText,"Eingabe lschen");
    ichSelbst^.LoeschenKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, LoeschenKnopfXPos, KnopfY2Pos, CAST(PROC,LoeschenKnopfCallback));

    String.Schreibe(KnopfText,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, AbbrechenKnopfXPos, KnopfY2Pos, CAST(PROC,AbbrechenKnopfCallback));
    String.Dispose(KnopfText);

    IF TRACE THEN WriteString("FBuchenKst.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;



PROCEDURE BArtListeKnopfCallback();
  VAR
    Ueberschrift: String.TString;
    Listenelement: String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFBuchenKst;
    BArtStringListe: Stringliste.TStringliste;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.BArtListeKnopfCallback Begin"); WriteLn; END;

    (* Erzeuge den Listeninhalt *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);

    BArtStringListe := Stringliste.Create();
    Listenelement := String.Create();
    String.Schreibe (Listenelement,"Abschluss");
    Stringliste.Append(BArtStringListe,Listenelement);
    String.Schreibe (Listenelement,"Gehalt");
    Stringliste.Append(BArtStringListe,Listenelement);
    String.Schreibe (Listenelement,"Sonstiges");
    Stringliste.Append(BArtStringListe,Listenelement);
    String.Schreibe (Listenelement,"WG");
    Stringliste.Append(BArtStringListe,Listenelement);
    ichSelbst^.BArtStringListe:=BArtStringListe;
    Ueberschrift := String.Create();
    String.Schreibe (Ueberschrift, "Buchungsart waehlen");
    ichSelbst^.BArtListenHdle := StelleListeDar(ichSelbst^.BArtStringListe,Ueberschrift,4,
                             ichSelbst^.WinHdle,300,70,CAST(PROC,BArtListeCallback));

    DeaktFAnlegen();

    IF TRACE THEN WriteString("FBuchenKst.BArtListeKnopfCallback End"); WriteLn; END;
  END BArtListeKnopfCallback;


PROCEDURE BArtListeCallback(Nr:INTEGER);
  CONST
  VAR
    MeldString, KstIDString, NameString, JahrString, KontingentString,
						AequivalentString: String.TString;
    MeldStr, KstIDStr, NameStr, JahrStr, KontingentStr, AequivalentStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFBuchenKst;
    ElementString: String.TString;
    TextStr: ARRAY [1..100] OF CHAR;
    ElementStr: ARRAY [1..100] OF CHAR;

  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.BArtListeCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);

    ElementString := String.Create();
    LiesListenelement(ichSelbst^.BArtListenHdle, Nr, ElementString);
    String.Lies(ElementString, ElementStr);
    String.Equalize(ichSelbst^.BuchungsArtString, ElementString);
    AnzeigenBuchungsArt();

    ReaktFAnlegen();
    EntferneListe(ichSelbst^.BArtListenHdle);

    IF TRACE THEN WriteString("FBuchenKst.BArtListeCallback End"); WriteLn; END;
  END BArtListeCallback;





PROCEDURE AbschlussKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.AbschlussKnopfCallback Begin"); WriteLn; END;

    IF TRACE THEN WriteString("FBuchenKst.AbschlussKnopfCallback End"); WriteLn; END;
  END AbschlussKnopfCallback;

PROCEDURE GehaltKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.GehaltKnopfCallback Begin"); WriteLn; END;

    IF TRACE THEN WriteString("FBuchenKst.GehaltKnopfCallback End"); WriteLn; END;
  END GehaltKnopfCallback;

PROCEDURE SonstigesKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.SonstigesKnopfCallback Begin"); WriteLn; END;

    IF TRACE THEN WriteString("FBuchenKst.SonstigesKnopfCallback End"); WriteLn; END;
  END SonstigesKnopfCallback;

PROCEDURE WGKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.WGKnopfCallback Begin"); WriteLn; END;

    IF TRACE THEN WriteString("FBuchenKst.WGKnopfCallback End"); WriteLn; END;
  END WGKnopfCallback;



PROCEDURE AbbrechenKnopfCallback();
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.AbbrechenKnopfCallback Begin"); WriteLn; END;

    DisposeFAnlegen();

    IF TRACE THEN WriteString("FBuchenKst.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE BuchenKnopfCallback();
  CONST
  VAR
    MeldString, KstIDString, NameString, JahrString, BetragString, BuchungsArtString: String.TString;
    MeldStr, KstIDStr, NameStr, JahrStr, BetragStr, BuchungsArtStr: ARRAY[1..200] OF CHAR;
    Betrag: INTEGER;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFBuchenKst;
    Format: ConvTypes.ConvResults;
    DatenOkay: BOOLEAN;
(*  KstID: TKstID;
    Kst: TKst;
    Jahr: TJahr;
    Bu: TBu;
*)

  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.BuchenKnopfCallback Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);

    DatenOkay:=TRUE;

    MeldString:=String.Create();

    String.Lies(ichSelbst^.KstIDString, KstIDStr);
    WriteString("Buchen KstID:"); WriteString(KstIDStr); WriteString(":");


    BetragString:=String.Create();
    LiesZeile(ichSelbst^.BetragHdle, BetragString);
    String.Lies(BetragString, BetragStr);
    WriteString("Betrag:"); WriteString(BetragStr); WriteString(":");
    String.Lies(ichSelbst^.BuchungsArtString, MeldStr);
    WriteString(MeldStr); WriteString(":"); WriteLn;

    (* Kontingent Prfen und konvertieren *)
    IF StrToInteger(BetragStr,Betrag) THEN
      WriteString(" Betrag:"); WriteInt(Betrag,5); WriteString(":");
    ELSE
      DatenOkay:=FALSE;
      AusgebenMeldung(" Der Buchungsbetrag ist ungueltig (nicht ganzzahlig)");
    END;
    WriteLn;


    (* Sind die eingegeben Buchungsdaten okay, dann wird die Buchung durchgefuehrt *)
    IF DatenOkay THEN
(*     Bu:=CreateBu();
       SetzeBetraginBu(Bu, Betrag);
       SetzeBuchungsArtinBu(Bu, ichSelbst^.BuchungsArt);
       SetzeKstIDinBu(Bu, ichSelbst^.KstID);     *)
       (* SetzeVtrIDinBu    VrtID  kann nicht gesetzt werden, da keine Created werden kann *)
(*     SetzeGebuchtAminBu(Bu, CreateDatum());
       SetzeStorniertAminBu(Bu, CreateDatum());
*)

(*
       IF BearbeitenBuchenKst(Bu, ichSelbst^.Kst, MeldString) THEN
*)
         AusgebenMeldung("Buchung wurde durchgefuehrt");
(*
       ELSE
         String.Lies(MeldString, MeldStr);
         Strings.Append("Meldung Bu:", MeldStr);
         AusgebenMeldung(MeldStr);
       END;
*)
    END;

    IF TRACE THEN WriteString("FBuchenKst.BuchenKnopfCallback End"); WriteLn; END;
  END BuchenKnopfCallback;




PROCEDURE LoeschenKnopfCallback();
   VAR
    MeldHandle: ADDRESS;
    ichSelbst: TPFBuchenKst;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.LoeschenKnopfCallback Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);

    DeaktFAnlegen();

    LoeschenEinAusgabeFelder();
    InitEinAusgabeFelder();

    ReaktFAnlegen();

    IF TRACE THEN WriteString("FBuchenKst.LoeschenKnopfCallback Begin"); WriteLn; END;
  END LoeschenKnopfCallback;





PROCEDURE CreateFAnlegen(inKstIDString:String.TString);
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(300);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      WinHdle: ADDRESS;
      ichSelbst: TPFBuchenKst;
      meineAddr: ADDRESS;
      reaktProc: TProc;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.CreateFAnlegen Begin"); WriteLn; END;

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"Kostenstelle buchen");
    ALLOCATE (ichSelbst, TSIZE(TFBuchenKstDS));
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);
    ichSelbst^.BuchungsArtAktiv:=FALSE;
    meineAddr:= CAST(ADDRESS, ichSelbst);

    Push(ReaktFAnlegen, meineAddr);
    ichSelbst^.KstIDString:=inKstIDString;
    AktivFAnlegen();

    IF TRACE THEN WriteString("FBuchenKst.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;




PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBuchenKst;

  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.DisposeFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);
    LoeschenEinAusgabeFelder();
    EntferneKnopf(ichSelbst^.BArtListeKnopfHdle);
    EntferneKnopf(ichSelbst^.BuchenKnopfHdle);
    EntferneKnopf(ichSelbst^.LoeschenKnopfHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);
    EntferneFenster(ichSelbst^.WinHdle);
    Pop();
    Top(reaktProc, meineAddr);
    reaktProc();

    IF TRACE THEN WriteString("FBuchenKst.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBuchenKst;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.DeaktFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);
    (*  Deaktiviere Knpfe  *)
    SetzeKnopf(ichSelbst^.BArtListeKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.BuchenKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.LoeschenKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);

    IF TRACE THEN WriteString("FBuchenKst.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBuchenKst;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.ReaktFAnlegen Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);
    (* Aktiviere alle Knoepfe *)
    SetzeKnopf(ichSelbst^.BArtListeKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.BuchenKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.LoeschenKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);

    IF TRACE THEN WriteString("FBuchenKst.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;



PROCEDURE InitEinAusgabeFelder();
  CONST
      XPos=INT(40);
      KstIDYPos=INT(50);
      KstIDLaen=INT(5);           
      NameYPos=INT(70);
      NameLaen=INT(20);           
      JahrYPos=INT(90);
      JahrLaen=INT(4);           
      GesperrtAmYPos=INT(110);
      GesperrtAmLaen=INT(10);
      LiquidiertAmYPos=INT(130);
      LiquidiertAmLaen=INT(10);
      BetragYPos=INT(170);
      BetragLaen=INT(4);
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBuchenKst;
      Text, Inhalt: String.TString;
      MeldStr: ARRAY [1..200] OF CHAR;
      ZWString, MeldString: String.TString;
      DatumString, KstIDString, NameString, JahrString, BetragString,GesperrtAmString,
					LiquidiertAmString, BuchungsArtString: String.TString;
      KstIDStr, NameStr, JahrStr, BetragStr, BuchungsArtStr, LiquidiertAmStr,
      					GesperrtAmStr: ARRAY[1..200] OF CHAR;
      Betrag: INTEGER;
(*
      Jahr: Datum.TJahr;
      EingegebenAm,
      GesperrtAm,
      LiquidiertAm: Datum.TDatum;
      Datum: Datum.TDatum;
*)
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.InitEinAusgabeFelde Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);

    Text := String.Create();
    Inhalt := String.Create();

    KstIDString:=ichSelbst^.KstIDString;


(*
    IF SearchKstZuKstID(ichSelbst^.KstID, ichSelbst^.Kst) THEN
      LiesNameinKst(NameString,ichSelbst^.Kst);
      LiesJahrinKst(Jahr,ichSelbst^.Kst);
      LiesEingAminKst(EingegebenAm, ichSelbst^.Kst);
      LiesGesperrtAminKst(GesperrtAm, ichSelbst^.Kst);
      LiesLiquidAminKst(LiquidiertAm, ichSelbst^.Kst);
*)

      String.Schreibe(Text,"KostenstellenID:  ");
      String.Anhaengen(KstIDString, Text);
      ichSelbst^.KstIDHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, KstIDYPos);


      ZWString := String.Create();
      String.Schreibe(ZWString,"Name der Kostenstelle");
      NameString:=ZWString;

      String.Schreibe(Text,"Name:  ");
      String.Anhaengen(NameString, Text);
      ichSelbst^.NameHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, NameYPos);



    (*  Jahr ausgeben  *)
      DatumString := String.Create();
      String.Schreibe(DatumString,"01.01.2001");
(*
      Datum:=Datum.CreateDatum();
      IF Datum.DatumVonString(DatumString, Datum, MeldString) THEN
        Datum.SetzeJahrInDatum(Datum, Jahr);
      ELSE
        String.Lies(MeldString, MeldStr);
        Strings.Append("Meldung zu Datum:", MeldStr);
        AusgebenMeldung(MeldStr);
      END;
      DatumString:=Datum.DatumAlsString(Datum);
*)



      JahrString := String.Create();
      String.Auslesen(DatumString,6,4,JahrString);

      String.Schreibe(Text,"Jahr:  ");
      String.Anhaengen(JahrString, Text);
      ichSelbst^.JahrHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, JahrYPos);



      ZWString := String.Create();
      String.Schreibe(ZWString,"01.12.2001");
      GesperrtAmString:=ZWString;
(*
      IF Datum.IsDatumEternity(GesperrtAm) THEN
        ZWString := String.Create();
        String.Schreibe(ZWString,"nicht gesperrt");
        GesperrtAmString:=ZWString;              (* nur wenn UNDEF *)
*)
(*
      ELSE
        GesperrtAmString:=Datum.DatumAlsString(GesperrtAm);
      END;

      String.Schreibe(Text,"gesperrt am:  ");
      String.Anhaengen(GesperrtAmString, Text);
      ichSelbst^.GesperrtAmHdle:=StelleMeldungDar(Text, FALSE, ichSelbst^.WinHdle, XPos, GesperrtAmYPos);
*)


      Betrag:=123;
      WholeStr.IntToStr(Betrag, BetragStr);
      BetragString := String.Create();
(*      String.Schreibe(BetragString, BetragStr); *)
      String.Schreibe(Text,"Buchungsbetrag:");
      ichSelbst^.BetragHdle:=StelleZeileDar(Text, BetragString, BetragLaen,
	    					ichSelbst^.WinHdle, XPos, BetragYPos);

      BuchungsArtString := String.Create();
      String.Schreibe(BuchungsArtString,"Gehalt");
      ichSelbst^.BuchungsArtString:=BuchungsArtString;
      AnzeigenBuchungsArt();


(*
    ELSE
      MeldString := String.Create();
      String.Schreibe(MeldString,"Die Kst wurden nicht gefunden !? KstID:");
      String.Anhaengen(KstIDString, MeldString);
      String.Lies(MeldString, MeldStr);
      AusgebenMeldung(MeldStr);
    END;
*)


    String.Dispose(Text);
    String.Dispose(Inhalt);

    IF TRACE THEN WriteString("FBuchenKst.InitEinAusgabeFelde End"); WriteLn; END;
  END InitEinAusgabeFelder;


PROCEDURE AnzeigenBuchungsArt();
  CONST
      XPos=INT(40);
      BuchungsArtYPos=INT(190);
      BuchungsArtLaen=INT(4);
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBuchenKst;
      Text: String.TString;
      MeldStr: ARRAY [1..200] OF CHAR;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.AnzeigeBuchungsArt Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);

    IF ichSelbst^.BuchungsArtAktiv THEN
      EntferneMeldung(ichSelbst^.BuchungsArtHdle);
    ELSE
      ichSelbst^.BuchungsArtAktiv:=TRUE;
    END;

    Text := String.Create();
    String.Schreibe(Text,"Buchungsart:  ");
    String.Anhaengen(ichSelbst^.BuchungsArtString, Text);
    ichSelbst^.BuchungsArtHdle:=StelleMeldungDar(Text, TRUE, ichSelbst^.WinHdle, XPos, BuchungsArtYPos);

(*  String.Lies(ichSelbst^.BuchungsArtString, MeldStr);
    WriteString(":"); WriteString(MeldStr); WriteString(":"); WriteLn;
*)

    IF TRACE THEN WriteString("FBuchenKst.AnzeigeBuchungsArt End"); WriteLn; END;
  END AnzeigenBuchungsArt;



PROCEDURE LoeschenEinAusgabeFelder();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFBuchenKst;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.LoeschenEinAusgabeFelde Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);


    EntferneMeldung(ichSelbst^.KstIDHdle);
    EntferneMeldung(ichSelbst^.NameHdle);
    EntferneMeldung(ichSelbst^.JahrHdle);
(*
    EntferneMeldung(ichSelbst^.GesperrtAmHdle);
*)
    EntferneZeile(ichSelbst^.BetragHdle);
    EntferneMeldung(ichSelbst^.BuchungsArtHdle);


    IF TRACE THEN WriteString("FBuchenKst.LoeschenEinAusgabeFelde End"); WriteLn; END;
  END LoeschenEinAusgabeFelder;



PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    ichSelbst: TPFBuchenKst;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FBuchenKst.AusgebenMeldung Begin"); WriteLn; END;

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFBuchenKst, meineAddr);
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);

    IF TRACE THEN WriteString("FBuchenKst.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
(*  IF TRACE THEN WriteString("FBuchenKst.StrToCardinal Begin"); WriteLn; END;  *)
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
(*    IF TRACE THEN WriteString("FBuchenKst.StrToCardinal End"); WriteLn; END;  *)
      RETURN TRUE;
    ELSE
(*    IF TRACE THEN WriteString("FBuchenKst.StrToCardinal End"); WriteLn; END;  *)
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
(*  IF TRACE THEN WriteString("FBuchenKst.StrToInteger Begin"); WriteLn; END;  *)
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
(*    IF TRACE THEN WriteString("FBuchenKst.StrToInteger End"); WriteLn; END;  *)
      RETURN TRUE;
    ELSE
(*    IF TRACE THEN WriteString("FBuchenKst.StrToInteger End"); WriteLn; END;  *)
      RETURN FALSE;
    END;
  END StrToInteger;





CONST
  TRACE=FALSE;
VAR
BEGIN;
END FBuchenKT.
