(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: FInfo.mod,v $
# $Author: Sopra $
# $Date: 2001/03/14 10:38:16 $
# $Revision: 1.10 $
# Bemerkungen:

IMPLEMENTATION MODULE FInfo;
Funktion: Inforetrieval

JZ

V 0.0   10.3.01  15:40


*)
(******************************************************************************)

IMPLEMENTATION MODULE FInfo;

(* System-Importe *)
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT 	CAST, ADR, ADDRESS, TSIZE;
FROM Storage IMPORT 	ALLOCATE, DEALLOCATE;
FROM InOut IMPORT 	WriteCard, WriteLn, WriteString, WriteInt;
IMPORT WholeConv;
IMPORT WholeStr;
IMPORT ConvTypes;
IMPORT String;  (*  "String" TString *)
IMPORT Strings; (*  "Str"   Strings  enthaelt Operationen fuer ARRAY OF CHAR Datentypen !! *)
IMPORT Stringliste;


(* HiKS-Importe *)
FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;

IMPORT Info;

IMPORT FListBox;


  TYPE 	TFInfoDS = RECORD
                               WinHdle : ADDRESS;
		               HKKnopfHdle : ADDRESS;
		               VtrKnopfHdle : ADDRESS;
		               BuKnopfHdle : ADDRESS;
		               WKKnopfHdle : ADDRESS;
		               VKKnopfHdle : ADDRESS;
		               TKKnopfHdle : ADDRESS;
		               KstKnopfHdle : ADDRESS;
			       AbbrechenKnopfHdle:ADDRESS;  		
  	      		     END;	
        TPFInfo = POINTER TO TFInfoDS;


(* --------------------------------------------------------------- *)

PROCEDURE AktivFAnlegen();
  CONST
    KnopfXPos=INT(100);
    AbbrechenKnopfXPos=INT(340);
    AbbrechenKnopfYPos=INT(260);
    HKKnopfYPos=INT(20);
    KstKnopfYPos=INT(50);
    BuKnopfYPos=INT(110);
    WKKnopfYPos=INT(140);
    TKKnopfYPos=INT(170);
    VKKnopfYPos=INT(200);
    VtrKnopfYPos=INT(80);
  VAR
    KnopfText     : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFInfo;
  BEGIN
    IF TRACE THEN WriteString("FInfo.AktivFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFInfo, meineAddr);

    (* Erzeuge den Fensterinhalt *)
    StelledarListe();

    KnopfText := String.Create();

    String.Schreibe(KnopfText,"a l l e   Hilfskraefte   anzeigen");
    ichSelbst^.HKKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, KnopfXPos, HKKnopfYPos, CAST(PROC,HKKnopfCallback));

    String.Schreibe(KnopfText,"a l l e   Kostenstellen   anzeigen");
    ichSelbst^.KstKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, KnopfXPos, KstKnopfYPos, CAST(PROC,KstKnopfCallback));

    String.Schreibe(KnopfText,"a l l e   Vertraege   anzeigen");
    ichSelbst^.VtrKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, KnopfXPos, VtrKnopfYPos, CAST(PROC,VtrKnopfCallback));

    String.Schreibe(KnopfText,"a l l e   Buchungen   anzeigen");
    ichSelbst^.BuKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, KnopfXPos, BuKnopfYPos, CAST(PROC,BuKnopfCallback));

    String.Schreibe(KnopfText,"a l l e   Weihnachtsgeldkonditionen   anzeigen");
    ichSelbst^.WKKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, KnopfXPos, WKKnopfYPos, CAST(PROC,WKKnopfCallback));

    String.Schreibe(KnopfText,"a l l e   Tarifkonditionen   anzeigen");
    ichSelbst^.TKKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, KnopfXPos, TKKnopfYPos, CAST(PROC,TKKnopfCallback));

    String.Schreibe(KnopfText,"a l l e   Vertragskonditionen   anzeigen");
    ichSelbst^.VKKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, KnopfXPos, VKKnopfYPos, CAST(PROC,VKKnopfCallback));

    String.Schreibe(KnopfText,"Abbrechen");
    ichSelbst^.AbbrechenKnopfHdle:=StelleKnopfDar(KnopfText,
	ichSelbst^.WinHdle, AbbrechenKnopfXPos, AbbrechenKnopfYPos, CAST(PROC,AbbrechenKnopfCallback));

    String.Dispose(KnopfText);

    IF TRACE THEN WriteString("FInfo.AktivFAnlegen End"); WriteLn; END;
  END AktivFAnlegen;




PROCEDURE StelledarListe();
  CONST
    KnopfYPos=INT(230);
    AbbrechenKnopfXPos=INT(410);
  VAR
    TextString, Ueberschrift: String.TString;
    Listenelement: String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFInfo;
    KstStringListe: Stringliste.TStringliste;
    I:INTEGER;
    TextStr, MeldStr, KstIDStr, NameStr, JahrStr, KontingentStr, AequivalentStr: ARRAY[1..200] OF CHAR;
  BEGIN
    IF TRACE THEN WriteString("FInfo.StelledarListe Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFInfo, meineAddr);


(*
    KstStringListe := Stringliste.Create();
    Listenelement := String.Create();

    String.Schreibe (Listenelement,"    5 Name der Kostenstell 2001 01.12.2001");
    Stringliste.Append(KstStringListe,Listenelement);

    FOR I:=1 TO 40 DO
      String.Schreibe (Listenelement,"92222 Name der Kostenstell 2001 01.12.2001");
      Stringliste.Append(KstStringListe,Listenelement);
    END;



    KstStringListe:=GibKstenAlsStringlisteInKsten();


    Ueberschrift := String.Create();
    String.Schreibe (Ueberschrift, "Kostenstelle, Auswahl mit linker Maustaste");
    String.Schreibe (Ueberschrift, "KstID     N  a  m  e               Jahr  GesperrtAm");
    ichSelbst^.ListenHdle := StelleListeDar(KstStringListe,Ueberschrift,9,
                             ichSelbst^.WinHdle,50,40,CAST(PROC,ListeCallback));
    String.Dispose(Ueberschrift);


    TextString := String.Create();
    Listenelement:=NIL;
    WHILE NOT (Stringliste.IsEmpty(KstStringListe)) DO
      Stringliste.GoStart(KstStringListe);
      Listenelement:=Stringliste.Current(KstStringListe);
      String.Auslesen(Listenelement,0,5,TextString);
      String.Lies(TextString, TextStr);
      WriteString("KstID:"); WriteString(TextStr); WriteString(":"); WriteLn;

      Stringliste.Delete(KstStringListe);
    END;
    Stringliste.Dispose(KstStringListe);

    IF Listenelement <> NIL THEN
      String.Dispose(Listenelement);
    END;
    String.Dispose(TextString);

*)

    IF TRACE THEN WriteString("FInfo.StelledarListe End"); WriteLn; END;
  END StelledarListe;





PROCEDURE BuKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFInfo;
    StringListe: Stringliste.TStringliste;
    FUeb, LBUeb, DRUeb, DRFUeb: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback Begin"); WriteLn; END;

    StringListe:=Info.ZeigeAlleBuen();


    FUeb := String.Create();
    String.Schreibe (FUeb,"  a l l e      Buchungen   anzeigen");

    LBUeb := String.Create();
    String.Schreibe (LBUeb,"BuID   KstID   VtrID    Betrag   Gebucht    BuArt   Storno ");

    DRUeb := String.Create();
    String.Schreibe (DRUeb,"              a l l e      Buchungen:");

    DRFUeb := String.Create();
    String.Schreibe (DRFUeb,"BuID   KstID  VtrID     Betrag   Gebucht     BuArt    Storno ");

    DisposeFAnlegen();

    FListBox.CreateFAnlegen(FUeb, LBUeb, DRUeb, DRFUeb, StringListe);
    (* Neues Fenster erzeugen *)

    String.Dispose(FUeb);
    String.Dispose(LBUeb);

    (* bereinigen *)
    WHILE NOT (Stringliste.IsEmpty(StringListe)) DO
      Stringliste.GoStart(StringListe);
      Stringliste.Delete(StringListe);
    END;
    Stringliste.Dispose(StringListe);

    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback End"); WriteLn; END;
  END BuKnopfCallback;



PROCEDURE HKKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFInfo;
    StringListe: Stringliste.TStringliste;
    FUeb, LBUeb, DRUeb, DRFUeb: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback Begin"); WriteLn; END;

    StringListe:=Info.ZeigeAlleHK();


    FUeb := String.Create();
    String.Schreibe (FUeb,"    a l l e     Hilfskrfte   anzeigen");

    LBUeb := String.Create();
    String.Schreibe (LBUeb,"      Hilfskrefte       ");

    DRUeb := String.Create();
    String.Schreibe (DRUeb,"           a l l e     Hilfskrfte:");

    DRFUeb := String.Create();
    String.Schreibe (DRFUeb,"");

    DisposeFAnlegen();

    FListBox.CreateFAnlegen(FUeb, LBUeb, DRUeb, DRFUeb, StringListe);
    (* Neues Fenster erzeugen *)

    String.Dispose(FUeb);
    String.Dispose(LBUeb);

    (* bereinigen *)
    WHILE NOT (Stringliste.IsEmpty(StringListe)) DO
      Stringliste.GoStart(StringListe);
      Stringliste.Delete(StringListe);
    END;
    Stringliste.Dispose(StringListe);

    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback End"); WriteLn; END;
  END HKKnopfCallback;



PROCEDURE KstKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFInfo;
    StringListe: Stringliste.TStringliste;
    FUeb, LBUeb, DRUeb, DRFUeb: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback Begin"); WriteLn; END;
    StringListe:=Info.ZeigeAlleKsten();

    FUeb := String.Create();
    String.Schreibe (FUeb,"      a l l e     Kostenstellen   anzeigen");

    LBUeb := String.Create();
    String.Schreibe (LBUeb,"KstID   N a m e                Jahr EinrDat    SperrDat LiquiDat  Konting   quival      RestEtat");

    DRUeb := String.Create();
    String.Schreibe (DRUeb,"                    a l l e     Kostenstellen:");

    DRFUeb := String.Create();
    String.Schreibe (DRFUeb,"KstID   N a m e            Jahr   EinrDat   SperrDat   LiquiDat    Konting    quival     RestEtat");

    DisposeFAnlegen();

    FListBox.CreateFAnlegen(FUeb, LBUeb, DRUeb, DRFUeb, StringListe);
    (* Neues Fenster erzeugen *)

    String.Dispose(FUeb);
    String.Dispose(LBUeb);

    (* bereinigen *)
    WHILE NOT (Stringliste.IsEmpty(StringListe)) DO
      Stringliste.GoStart(StringListe);
      Stringliste.Delete(StringListe);
    END;
    Stringliste.Dispose(StringListe);

    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback End"); WriteLn; END;
  END KstKnopfCallback;



PROCEDURE VtrKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFInfo;
    StringListe: Stringliste.TStringliste;
    FUeb, LBUeb, DRUeb, DRFUeb: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback Begin"); WriteLn; END;
    StringListe:=Info.ZeigeAlleVtre();

    FUeb := String.Create();
    String.Schreibe (FUeb,"     a l l e         Vertrge   anzeigen");

    LBUeb := String.Create();
    String.Schreibe (LBUeb,"VtrID PeID KstID Erstellt  Gltigvon Gltigbis Storno  Stdzl   Ttigkeit  Begrndung");

    DRUeb := String.Create();
    String.Schreibe (DRUeb,"                            a l l e         Vertrge:");

    DRFUeb := String.Create();
    String.Schreibe (DRFUeb,"VtrID PeID  KstID Erstellt   Gltigvon  Gltigbis    Storno   Stdzl  Ttigkeit  Begrndung");

    DisposeFAnlegen();

    FListBox.CreateFAnlegen(FUeb, LBUeb, DRUeb, DRFUeb, StringListe);
    (* Neues Fenster erzeugen *)

    String.Dispose(FUeb);
    String.Dispose(LBUeb);

    (* bereinigen *)
    WHILE NOT (Stringliste.IsEmpty(StringListe)) DO
      Stringliste.GoStart(StringListe);
      Stringliste.Delete(StringListe);
    END;
    Stringliste.Dispose(StringListe);

    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback End"); WriteLn; END;
  END VtrKnopfCallback;



PROCEDURE WKKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFInfo;
    StringListe: Stringliste.TStringliste;
    FUeb, LBUeb, DRUeb, DRFUeb: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback Begin"); WriteLn; END;
    StringListe:=Info.ZeigeAlleWKond();

    FUeb := String.Create();
    String.Schreibe (FUeb,"    a l l e    Weihnachtsgeldkonditionen   anzeigen");

    LBUeb := String.Create();
    String.Schreibe (LBUeb,"WKID    v o n       b i s          BM  Stag");

    DRUeb := String.Create();
    String.Schreibe (DRUeb,"  a l l e    Weihnachtsgeldkonditionen:");

    DRFUeb := String.Create();
    String.Schreibe (DRFUeb,"WKID    v o n       b i s      BM  Stag");

    DisposeFAnlegen();

    FListBox.CreateFAnlegen(FUeb, LBUeb, DRUeb, DRFUeb, StringListe);
    (* Neues Fenster erzeugen *)

    String.Dispose(FUeb);
    String.Dispose(LBUeb);

    (* bereinigen *)
    WHILE NOT (Stringliste.IsEmpty(StringListe)) DO
      Stringliste.GoStart(StringListe);
      Stringliste.Delete(StringListe);
    END;
    Stringliste.Dispose(StringListe);

    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback End"); WriteLn; END;
  END WKKnopfCallback;



PROCEDURE TKKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFInfo;
    StringListe: Stringliste.TStringliste;
    FUeb, LBUeb, DRUeb, DRFUeb: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback Begin"); WriteLn; END;
    StringListe:=Info.ZeigeAlleTKond();

    FUeb := String.Create();
    String.Schreibe (FUeb,"    a l l e     Tarifkonditionen   anzeigen");

    LBUeb := String.Create();
    String.Schreibe (LBUeb,"TKID    v o n       b i s         Stundensatz");

    DRUeb := String.Create();
    String.Schreibe (DRUeb,"      a l l e     Tarifkonditionen:");

    DRFUeb := String.Create();
    String.Schreibe (DRFUeb,"TKID    v o n       b i s    Stundensatz");

    DisposeFAnlegen();

    FListBox.CreateFAnlegen(FUeb, LBUeb, DRUeb, DRFUeb, StringListe);
    (* Neues Fenster erzeugen *)

    String.Dispose(FUeb);
    String.Dispose(LBUeb);

    (* bereinigen *)
    WHILE NOT (Stringliste.IsEmpty(StringListe)) DO
      Stringliste.GoStart(StringListe);
      Stringliste.Delete(StringListe);
    END;
    Stringliste.Dispose(StringListe);

    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback End"); WriteLn; END;
  END TKKnopfCallback;



PROCEDURE VKKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFInfo;
    StringListe: Stringliste.TStringliste;
    FUeb, LBUeb, DRUeb, DRFUeb: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback Begin"); WriteLn; END;
    StringListe:=Info.ZeigeAlleVKond();

    FUeb := String.Create();
    String.Schreibe (FUeb,"      a l l e           Vertragskonditionen   anzeigen");

    LBUeb := String.Create();
    String.Schreibe (LBUeb,"VKID      v o n       b i s         BHD  STOG");

    DRUeb := String.Create();
    String.Schreibe (DRUeb,"  a l l e           Vertragskonditionen:");

    DRFUeb := String.Create();
    String.Schreibe (DRFUeb,"VKID     v o n      b i s     BHD   STOG");

    DisposeFAnlegen();

    FListBox.CreateFAnlegen(FUeb, LBUeb, DRUeb, DRFUeb, StringListe);
    (* Neues Fenster erzeugen *)

    String.Dispose(FUeb);
    String.Dispose(LBUeb);

    (* bereinigen *)
    WHILE NOT (Stringliste.IsEmpty(StringListe)) DO
      Stringliste.GoStart(StringListe);
      Stringliste.Delete(StringListe);
    END;
    Stringliste.Dispose(StringListe);

    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback End"); WriteLn; END;
  END VKKnopfCallback;



PROCEDURE AbbrechenKnopfCallback();
  VAR
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFInfo;
  BEGIN
    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback Begin"); WriteLn; END;
    DisposeFAnlegen();
    Top(reaktProc, meineAddr);
    reaktProc();
    IF TRACE THEN WriteString("FInfo.AbbrechenKnopfCallback End"); WriteLn; END;
  END AbbrechenKnopfCallback;



PROCEDURE ListeCallback(Nr:INTEGER);
  CONST
  VAR
    MeldString, KstIDString, NameString, JahrString, KontingentString,
						AequivalentString: String.TString;
    MeldStr, KstIDStr, NameStr, JahrStr, KontingentStr, AequivalentStr: ARRAY[1..200] OF CHAR;
    reaktProc: TProc;
    meineAddr: ADDRESS; 
    ichSelbst: TPFInfo;
    ElementString: String.TString;
    TextStr: ARRAY [1..100] OF CHAR;
    ElementStr: ARRAY [1..100] OF CHAR;

  BEGIN
    IF TRACE THEN WriteString("FInfo.ListeCallback Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFInfo, meineAddr);
(*
    ElementString := String.Create();
    KstIDString := String.Create();

    LiesListenelement(ichSelbst^.ListenHdle, Nr, ElementString);
    String.Lies(ElementString, ElementStr);
    String.Auslesen(ElementString,0,5,KstIDString);
    String.Lies(KstIDString, MeldStr);

    WriteString("KstID:"); WriteString(MeldStr); WriteString(":"); WriteLn;


    (* aktuelles Fenster entfernen *)
    DisposeFAnlegen();
    (* Neues Fenster erzeugen und KstID der ausgewaehlten Kst uebergeben *)
    FBuchenKst.CreateFAnlegen(KstIDString);

    (* bereinigen *)
    String.Dispose(ElementString);
    String.Dispose(KstIDString);
*)

    IF TRACE THEN WriteString("FInfo.ListeCallback End"); WriteLn; END;
  END ListeCallback;




PROCEDURE CreateFAnlegen();
  CONST
      FXPos=INT(300);
      FYPos=INT(300);
      FHoehe=INT(300);
      FBreite=INT(500);
  VAR FensterUeberschrift: String.TString;
      ichSelbst: TPFInfo;
      meineAddr: ADDRESS;
  BEGIN
    IF TRACE THEN WriteString("FInfo.CreateFAnlegen Begin"); WriteLn; END;

    (* Fenstar ADO anlegen; ReaktProcedur- und ADO-Adresse auf den Stapel geben *)
    NEW(ichSelbst);
    meineAddr:= CAST(ADDRESS, ichSelbst);
    Push(ReaktFAnlegen, meineAddr);

    FensterUeberschrift := String.Create();
    String.Schreibe( FensterUeberschrift,"          I    n    f    o    r    e    t    r    i    e    v    a    l");
    ichSelbst^.WinHdle:=NeuesFenster(FensterUeberschrift,FXPos,FYPos,FHoehe,FBreite);

    AktivFAnlegen();

    IF TRACE THEN WriteString("FInfo.CreateFAnlegen End"); WriteLn; END;
  END CreateFAnlegen;



PROCEDURE DisposeFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFInfo;
  BEGIN
    IF TRACE THEN WriteString("FInfo.DisposeFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFInfo, meineAddr);

(*  EntferneListe(ichSelbst^.ListenHdle);
    EntferneKnopf(ichSelbst^.AbbrechenKnopfHdle);  *)

    EntferneFenster(ichSelbst^.WinHdle);

    (* Fenster ADO loeschen; Stapelelement des aktuellen Fensters entfernen  *)
    DISPOSE(ichSelbst);
    Pop();

    IF TRACE THEN WriteString("FInfo.DisposeFAnlegen End"); WriteLn; END;
  END DisposeFAnlegen;



PROCEDURE DeaktFAnlegen();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFInfo;
  BEGIN
    IF TRACE THEN WriteString("FInfo.DeaktFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFInfo, meineAddr);
    (*Deaktiviere Knpfe, Listboxen,... *)
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, FALSE);
(*
    EntferneListe(ichSelbst^.ListenHdle);
*)
    IF TRACE THEN WriteString("FInfo.DeaktFAnlegen End"); WriteLn; END;
  END DeaktFAnlegen;



PROCEDURE ReaktFAnlegen();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFInfo;
      Ueberschrift:String.TString;
  BEGIN
    IF TRACE THEN WriteString("FInfo.ReaktFAnlegen Begin"); WriteLn; END;
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFInfo, meineAddr);
    (* Aktiviere alle Knpfe, Listbox *)
    StelledarListe();
    SetzeKnopf(ichSelbst^.AbbrechenKnopfHdle, TRUE);
    IF TRACE THEN WriteString("FInfo.ReaktFAnlegen End"); WriteLn; END;
  END ReaktFAnlegen;




PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR 
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FInfo.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText); 
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FInfo.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;



PROCEDURE StrToCardinal(inStr:ARRAY OF CHAR; VAR outCard:CARDINAL):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToCard(inStr,outCard,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToCardinal;


PROCEDURE StrToInteger(inStr:ARRAY OF CHAR; VAR outInt:INTEGER):BOOLEAN;
  VAR
    Format: ConvTypes.ConvResults;
  BEGIN
    WholeStr.StrToInt(inStr,outInt,Format);
    IF Format = ConvTypes.strAllRight THEN
      RETURN TRUE;
    ELSE
      RETURN FALSE;
    END;
  END StrToInteger;




CONST
  TRACE=FALSE;
VAR
BEGIN;
END FInfo.
