

MODULE hiks;

FROM ProgArgs IMPORT GetArg;
FROM Types    IMPORT SHORTCARD,LONGCARD;
FROM args     IMPORT GetArgs, ArgTable;
FROM SYSTEM   IMPORT CAST, ADR, ADDRESS;
FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;
FROM InOut    IMPORT WriteString,WriteLn,WriteInt;


FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;  (*Fensterstapel fr Grabo*)

IMPORT Strings;
IMPORT String;
IMPORT Stringliste;
IMPORT Datum;
IMPORT Vtre;
IMPORT SysDat;
IMPORT Ksten;
IMPORT HKe;

(* Christian Sonnweber *)
IMPORT FLadenSysVw;                      (*Kind-Fenster*)
IMPORT FSichernSysVw;                    (*Kind-Fenster*)
IMPORT FSetDatumSysVw;                   (*Kind-Fenster*)
IMPORT FAnlegenVtrHKB;                   (*Kind-Fenster*)
IMPORT FAendernVtrHKB;                   (*Kind-Fenster*)

(*  Johann Zeiser *)
IMPORT FAnlegenKst;                     (*Kind-Fenster*)
IMPORT FSelBeaKst;                      (*Kind-Fenster*)
IMPORT FSelBuKst;                       (*Kind-Fenster*)
IMPORT FKondWkEin;                      (*Kind-Fenster*)
IMPORT FKondWkAnz;			(*Kind-Fenster*)
IMPORT FKondTkEin;                      (*Kind-Fenster*)
IMPORT FKondVtrEin;                     (*Kind-Fenster*)
IMPORT FKondTkAnz;                      (*Kind-Fenster*)
IMPORT FKondVtrAnz;                     (*Kind-Fenster*)
(* Johannes Magauer *)                  (*Kind-Fenster*)
IMPORT FAnlegenHK;                      (*Kind-Fenster*)
IMPORT FAendernHK;                      (*Kind-Fenster*)
IMPORT FSelektionHK;                    (*Kind-Fenster*)

VAR
  HauptFensterHandle	: ADDRESS;
  HKBMenuHandle		: ADDRESS;
  PSBMenuHandle		: ADDRESS;
  EndeKnopfHandle	: ADDRESS;
  DummyHandle		: ADDRESS;
  SysVwMenuHandle 	: ADDRESS;
  Args                  : ArgTable;	
  AnzArgs 		: CARDINAL;

TYPE
  DeAct = PROCEDURE();
  TCharString = ARRAY[0..255] OF CHAR;
  TTestArray  = ARRAY[0..30] OF CHAR;
(*----------------------------------------------------------------------------------------*)

PROCEDURE ErzeugeKnoepfe();
VAR Titel : String.TString;
BEGIN
  Titel := String.Create();
  String.Schreibe(Titel,"Ende");
  EndeKnopfHandle := StelleKnopfDar(Titel,HauptFensterHandle,10,10,CAST(PROC,EndeKnopfCallback));
END ErzeugeKnoepfe;

(*----------------------------------------------------------------------------------------*)

PROCEDURE EndeKnopfCallback();
VAR Abfragetext : String.TString;
BEGIN
  Abfragetext := String.Create();
  String.Schreibe(Abfragetext,"Wirklich beenden?");
  IF JaNeinAbfrage(Abfragetext)
  THEN
    EntferneKnopf(EndeKnopfHandle);
    EntferneFenster(HauptFensterHandle);
  END;
END EndeKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE SysVwMenuErstellen();

VAR
    MenuStringliste    : Stringliste.TStringliste;
    ErsterMenuEintrag,
    ZweiterMenuEintrag,
    DritterMenuEintrag,
    Ueberschrift       : String.TString;

BEGIN
    MenuStringliste := Stringliste.Create();
    ErsterMenuEintrag := String.Create();
    String.Schreibe (ErsterMenuEintrag,"System Laden");
    Stringliste.Append(MenuStringliste,ErsterMenuEintrag);

    ZweiterMenuEintrag := String.Create();
    String.Schreibe (ZweiterMenuEintrag,"System Sichern");
    Stringliste.Append(MenuStringliste,ZweiterMenuEintrag);

    DritterMenuEintrag := String.Create();
    String.Schreibe (DritterMenuEintrag,"Datum Eingeben");
    Stringliste.Append(MenuStringliste,DritterMenuEintrag);

    Ueberschrift := String.Create();
    String.Schreibe(Ueberschrift,"Systemverwaltung");
    SysVwMenuHandle := StelleMenueDar(MenuStringliste,Ueberschrift,
                       HauptFensterHandle,100,10,CAST(PROC,SysVwMenuCallback));
    SetzeMenue(SysVwMenuHandle,TRUE);
END SysVwMenuErstellen;

(*----------------------------------------------------------------------------------------*)


PROCEDURE SysVwMenuCallback (number : INTEGER);

  VAR
    Laenge               : INTEGER;
    NeuesElement,
    FensterUeberschrift,
    Loeschtext           : String.TString;

  BEGIN
    CASE number OF
           1 : DeActivate();
               FLadenSysVw.Create(CAST(ADDRESS,Activate));

         | 2 : DeActivate();
               FSichernSysVw.Create(CAST(ADDRESS,Activate));

         | 3 : DeActivate();
               Push(Activate,NIL);
               FSetDatumSysVw.Create();
    END
  END SysVwMenuCallback;

(* ---------------------------------------------------------------------------------- *)

PROCEDURE HKBMenuCallback (number : INTEGER);

  VAR
    Laenge               : INTEGER;
    NeuesElement,
    FensterUeberschrift,
    Loeschtext           : String.TString;

  BEGIN
    CASE number OF
          1 :  DeActivate();
               Push(Activate,NIL);
               FAnlegenHK.CreateFAnlegen();

         | 2 : DeActivate();
               Push(Activate,NIL);
               FSelektionHK.CreateFSelektion();

         | 3 :

         | 4 : DeActivate();
	       Push(Activate,NIL);
               FAnlegenVtrHKB.CreateFAnlegenVtr();

         (*      FAnlegenVtrHKB.Create(CAST(ADDRESS,Activate)); *)


         | 5 : DeActivate();
               FAendernVtrHKB.Create(CAST(ADDRESS,Activate));
    END
  END HKBMenuCallback;
(*-------------------------------------------------------------------------------------*)



PROCEDURE PSBMenuCallback (number : INTEGER);

  VAR
    Laenge               : INTEGER;
    NeuesElement,
    FensterUeberschrift,
    Loeschtext           : String.TString;

  BEGIN
    CASE number OF
          1 :  DeActivate();
               Push(Activate,NIL);
               FAnlegenKst.CreateFAnlegen();

         | 2 : DeActivate();
               Push(Activate,NIL);
               FSelBeaKst.CreateFAnlegen();

         | 3 : DeActivate();
               Push(Activate,NIL);
               FSelBuKst.CreateFAnlegen();

         | 5 : DeActivate();
               Push(Activate,NIL);
               FKondWkEin.CreateFAnlegen();

         | 6 : DeActivate();
               Push(Activate,NIL);
               FKondWkAnz.CreateFAnlegen();

         | 7 : DeActivate();
               Push(Activate,NIL);
               FKondTkEin.CreateFAnlegen();

         | 8 : DeActivate();
               Push(Activate,NIL);
               FKondVtrEin.CreateFAnlegen();

         | 9 : DeActivate();
               Push(Activate,NIL);
               FKondTkAnz.CreateFAnlegen();

         |10 : DeActivate();
               Push(Activate,NIL);
               FKondVtrAnz.CreateFAnlegen();

    END
  END PSBMenuCallback;

(*-----------------------------------------------------------------------------------*)

PROCEDURE HKBMenuErstellen();

  VAR
    MenuStringliste    : Stringliste.TStringliste;
    MenuEintrag,

    Ueberschrift       : String.TString;

  BEGIN
    MenuStringliste := Stringliste.Create();
    MenuEintrag := String.Create();

    String.Schreibe (MenuEintrag,"Hilfskraft Anlegen");
    Stringliste.Append(MenuStringliste,MenuEintrag);
    String.Schreibe (MenuEintrag,"Hiklfskraft Bearbeiten");
    Stringliste.Append(MenuStringliste,MenuEintrag);

    String.Schreibe (MenuEintrag,"-------------------");
    Stringliste.Append(MenuStringliste,MenuEintrag);
    String.Schreibe (MenuEintrag,"Vertrag Erzeugen & Buchen");
    Stringliste.Append(MenuStringliste,MenuEintrag);
    String.Schreibe  (MenuEintrag,"Vertrag Aendern");
    Stringliste.Append(MenuStringliste,MenuEintrag);

    Ueberschrift := String.Create();
    String.Schreibe(Ueberschrift,"Hilfskraftbeauftragter");
    HKBMenuHandle := StelleMenueDar(MenuStringliste,Ueberschrift,
                                    HauptFensterHandle,250,10,CAST(PROC,HKBMenuCallback));
    SetzeMenue(SysVwMenuHandle,TRUE);
  END HKBMenuErstellen;

(*-----------------------------------------------------------------------------------*)

PROCEDURE PSBMenuErstellen();

  VAR
    MenuStringliste    : Stringliste.TStringliste;
    MenuEintrag,
    Ueberschrift       : String.TString;

  BEGIN
    MenuStringliste := Stringliste.Create();
    MenuEintrag := String.Create();
    String.Schreibe (MenuEintrag,"Kostenstelle anlegen");
    Stringliste.Append(MenuStringliste,MenuEintrag);
    String.Schreibe (MenuEintrag,"Kostenstelle bearbeiten");
    Stringliste.Append(MenuStringliste,MenuEintrag);
    String.Schreibe (MenuEintrag,"Kostenstelle buchen");
    Stringliste.Append(MenuStringliste,MenuEintrag);
    String.Schreibe (MenuEintrag,"-----------------------------------------");
    Stringliste.Append(MenuStringliste,MenuEintrag);
    String.Schreibe (MenuEintrag,"Weihnachtsgeldkondition einfgen");
    Stringliste.Append(MenuStringliste,MenuEintrag);
    String.Schreibe (MenuEintrag,"gueltige Weihnachtsgeldkondition anzeigen");
    Stringliste.Append(MenuStringliste,MenuEintrag);
    String.Schreibe (MenuEintrag,"Tarifkondition einfuegen");
    Stringliste.Append(MenuStringliste,MenuEintrag);
    String.Schreibe (MenuEintrag,"gueltige Tarifkondition anzeigen");
    Stringliste.Append(MenuStringliste,MenuEintrag);
    String.Schreibe (MenuEintrag,"Vertragskondition einfuegen");
    Stringliste.Append(MenuStringliste,MenuEintrag);
    String.Schreibe (MenuEintrag,"gueltige Vertragskondition anzeigen");
    Stringliste.Append(MenuStringliste,MenuEintrag);

    Ueberschrift := String.Create();
    String.Schreibe(Ueberschrift,"Personalsachbearbeiter");
    PSBMenuHandle := StelleMenueDar(MenuStringliste,Ueberschrift,
                       HauptFensterHandle,420,10,CAST(PROC,PSBMenuCallback));

    SetzeMenue(SysVwMenuHandle,TRUE);
  END PSBMenuErstellen;

(*-----------------------------------------------------------------------------------*)

PROCEDURE DeActivate();
BEGIN

  SetzeMenue(SysVwMenuHandle,FALSE);
  SetzeMenue(HKBMenuHandle,FALSE);
  SetzeMenue(PSBMenuHandle,FALSE);
  SetzeKnopf(EndeKnopfHandle,FALSE);
END DeActivate;

(*-----------------------------------------------------------------------------------*)

PROCEDURE Activate();
BEGIN

  WriteString("hiks.Activate");WriteLn;
  SetzeMenue(SysVwMenuHandle,TRUE);
  WriteString("hiks.Activate.SetzeMenue(SysVwMenuHandle,TRUE);");WriteLn;
  SetzeMenue(HKBMenuHandle,TRUE);
  WriteString("hiks.Activate.SetzeMenue(HKBMenuHandle,TRUE)");WriteLn;
  SetzeMenue(PSBMenuHandle,TRUE);
  WriteString("hiks.Activate.SetzeMenue(PSBMenuHandle,TRUE)");WriteLn;
  SetzeKnopf(EndeKnopfHandle,TRUE);
  WriteString("hiks.Activate.SetzeKnopf(EndeKnopfHandle,TRUE)");WriteLn;
END Activate;

(*-----------------------------------------------------------------------------------*)

PROCEDURE StC(inStr : String.TString) : TCharString;
(*Umwandlung von TString nach ARRAY OF CHAR = TCharString*)
VAR outcharfeld : TCharString;
BEGIN
 String.Lies(inStr,outcharfeld);
 RETURN outcharfeld;
END StC;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ErzeugeTestDaten();
											(*------------- LOKALE PROCEDURE-----------------*)
PROCEDURE GeneriereUndInsertVertrag ( inPersID     : HKe.TPersID;
																			inKstID      : Ksten.TKstID;
                                      inStdZahl    : CARDINAL;
                                      inTaetigkeit : TTestArray;
                                      inBegruendung: TTestArray;
                                      inGueltigVon : TTestArray;
                                      inGueltigBis : TTestArray   );
VAR
   mVertrag     : Vtre.TVtr;
   mKstId  			: Ksten.TKstID;
   mHilfsKraft  : HKe.THK;
   mTaetig		  : String.TString;
   mBegruend		: String.TString;
   s1    				: String.TString;
   s2						: String.TString;
   errmsg				: String.TString;
   mGueltigBis  : Datum.TDatum;
   mGueltigVon  : Datum.TDatum;
   ok						: BOOLEAN;
BEGIN
   errmsg    := String.Create();
   mTaetig   := String.Create();
   s1 := String.Create();
   mBegruend := String.Create();

   mVertrag  := Vtre.CreateVtr();

   (*PersId*)
   Vtre.SetzePersIDinVtr (mVertrag,inPersID);

   (*KostenstellenID*)
   Vtre.SetzeKstIDinVtr (mVertrag,inKstID);

   (*Taetigkeite*)
   String.Schreibe(mTaetig,inTaetigkeit);
   ok := Vtre.SetzeTaetigktinVtr (mVertrag,s1);

   (*Begruendunge*)
   String.Schreibe(mBegruend,inBegruendung);
   ok := Vtre.SetzeBegruendinVtr (mVertrag,mBegruend);

  (*GueltigVOn *)
   String.Schreibe(s1,inGueltigVon);
   ok := Datum.DatumVonString (s1,mGueltigVon,errmsg);
   WriteString(StC(errmsg));WriteLn();
   Vtre.SetzeGueltigVoninVtr (mVertrag,mGueltigVon);

   (*GueltigBis*)
   String.Schreibe(s1,inGueltigBis);
   ok := Datum.DatumVonString (s1,mGueltigBis,errmsg);
   WriteString(StC(errmsg));WriteLn();
   Vtre.SetzeGueltigBisinVtr (mVertrag,mGueltigBis);

END GeneriereUndInsertVertrag;

											(*------------- LOKALE PROCEDURE-----------------*)

PROCEDURE ErzeugeHKUndInsert(inPersonalNr : CARDINAL;
                             inName       : TTestArray);

VAR mHilfsKraft : HKe.THK;
    s1,s2,s3    : String.TString;
    errmsg			: String.TString;
    ok					: BOOLEAN;
BEGIN

   mHilfsKraft := HKe.CreateHK();
   HKe.SetzePersonalnrinHK (mHilfsKraft,inPersonalNr);

   s1 := String.Create();
   String.Schreibe(s1,inName);
   HKe.SetzeNameinHK (mHilfsKraft,s1);
   ok := HKe.InsertHK(mHilfsKraft,errmsg);
END ErzeugeHKUndInsert;

											(*------------- LOKALE PROCEDURE-----------------*)

  PROCEDURE KstenInit;
  VAR aktStringID, aktStringName : String.TString;
  BEGIN

    WriteLn; WriteLn;
    WriteString ("Kostenstellen initialisieren"); WriteLn;
    WriteString ("============================"); WriteLn;


    aktStringID := String.Create();
    aktStringName := String.Create ();

    (* String.Schreibe ( aktStringID, "125"); *)
    String.Schreibe (aktStringID, "125");
    String.Schreibe (aktStringName, "Kostenstelle 125");
    CreateKstAndInsert (aktStringID, aktStringName);

    String.Schreibe (aktStringID, "126");
    String.Schreibe (aktStringName, "Kostenstelle 126");
    CreateKstAndInsert (aktStringID, aktStringName);

    String.Schreibe (aktStringID, "127");
    String.Schreibe (aktStringName, "Kostenstelle 127");
    CreateKstAndInsert (aktStringID, aktStringName);

    String.Schreibe (aktStringID, "128");
    String.Schreibe (aktStringName, "Kostenstelle 128");
    CreateKstAndInsert (aktStringID, aktStringName);

    String.Schreibe (aktStringID, "129");
    String.Schreibe (aktStringName, "Kostenstelle 129");
    CreateKstAndInsert (aktStringID, aktStringName);

    String.Schreibe (aktStringID, "130");
    String.Schreibe (aktStringName, "Kostenstelle 130");
    CreateKstAndInsert (aktStringID, aktStringName);

    (* Fehler provozieren *)

    (*CreateKstAndInsert (aktStringID, aktStringName);*)

    String.Dispose (aktStringID);
    String.Dispose (aktStringName);

  END KstenInit;

						(*------------- LOKALE PROCEDURE-----------------*)
  PROCEDURE CreateKstAndInsert (inID : String.TString; inName : String.TString);
  VAR kst, kst2 : Ksten.TKst;
      kstID : Ksten.TKstID;
      outMessage, tempDatumString : String.TString;
      tempDatum : Datum.TDatum;
      tempJahr : Datum.TJahr;
      funkt : BOOLEAN;
      arrayofchar : ARRAY [1..255] OF CHAR;
  BEGIN

    kst := Ksten.CreateKst();
    kstID := Ksten.StringInKstID (inID);
    Ksten.SetzeKIDinKst (kstID, kst);
    Ksten.SetzeNameinKst (kst, inName);

    tempDatumString := String.Create();
    String.Schreibe (tempDatumString, "01.03.2001");

    outMessage := String.Create();
    IF Datum.DatumVonString (tempDatumString, tempDatum, outMessage)
    THEN
       tempJahr := Datum.LiesJahrInDatum (tempDatum);
       Ksten.SetzeJahrinKst (kst, tempJahr);
    ELSE
       WriteString ("Fehler bei Datumskonvertierung String -> Datum");
       WriteLn;
    END;
    String.Dispose (outMessage);


    IF Ksten.InsertKst (kst, outMessage)
    THEN WriteString ("-> Kostenstelle ");
         String.Lies (inID, arrayofchar) ;
         WriteString (arrayofchar);
         WriteString (" erfolgreich in den Ordner aufgenommen"); WriteLn;
    ELSE
         WriteString ("-> FEHLER: Kostenstelle ");
         String.Lies (inID, arrayofchar) ;
         WriteString (arrayofchar);
         WriteString (" nicht aufnehmbar"); WriteLn;
         String.Dispose (outMessage);
    END;

    Ksten.DisposeKst (kst);
    Ksten.DisposeKstID (kstID);

  END CreateKstAndInsert;


										(*------------- BEGIN HauptProcedure-----------------*)

VAR mHK 			:  HKe.THK;
    mKst			:  Ksten.TKst;
    mPersID   :  HKe.TPersID;
    mKstID    :  Ksten.TKstID;
    i					:  CARDINAL;
    ok				:  BOOLEAN;
BEGIN
(* Erzeuge Hilfskraefte *)
 ErzeugeHKUndInsert(00231,"Mller");
 ErzeugeHKUndInsert(00002,"Maier");
 ErzeugeHKUndInsert(00003,"Lang");
 ErzeugeHKUndInsert(00004,"Schuster");
 ErzeugeHKUndInsert(00005,"Schnhammer");
 ErzeugeHKUndInsert(00006,"Feichtelbauer");
 ErzeugeHKUndInsert(00123,"Walser");
 KstenInit();

END ErzeugeTestDaten;
(*-----------------------------------------------------------------------------------*)

BEGIN
  ErzeugeTestDaten();
  DummyHandle:=NIL;
  GetArgs (AnzArgs,Args);
  HauptFensterHandle := InitialisiereGrafik(AnzArgs,Args,0,80,50,790);
  ErzeugeKnoepfe();
  SysVwMenuErstellen();
  HKBMenuErstellen();
  PSBMenuErstellen();
  StarteGrafik();

END hiks.
