MODULE DruckTestStringliste;

FROM VDruck 	IMPORT	Print, PrintStringliste, initDrucker;
FROM String 	IMPORT 	TString, Schreibe, Create, Dispose, Lies;
FROM Stringliste IMPORT TStringliste;
FROM InOut IMPORT WriteString, WriteLn;
IMPORT Stringliste;

VAR 	S, outM, inText: TString;
	Liste  : TStringliste;
	
PROCEDURE StringAusgeben (inStr : TString);
   VAR Test : ARRAY[1..50] OF CHAR;
BEGIN
   WriteString("[");
   Lies (inStr, Test);
   WriteString(Test);
   WriteString("]");
   WriteLn;
END StringAusgeben;

(***************************************************************)

BEGIN
	Liste := Stringliste.Create();

	S := Create();
	Schreibe(S, "Erster Satz.");
	Stringliste.Insert(Liste, S);

	Schreibe(S, "Zweiter Satz.");
	Stringliste.Insert(Liste, S);

	Schreibe(S, "Dritter Satz.");
	Stringliste.Insert(Liste, S);

	Schreibe(S, "Vierter Satz.");
	Stringliste.Insert(Liste, S);

	Stringliste.GoStart(Liste);
	WHILE NOT Stringliste.OffEnd(Liste) DO			
		inText := Stringliste.Current(Liste);
		StringAusgeben(inText);
		Stringliste.StepNext(Liste);
	END; (*WHILE*)



	IF PrintStringliste(Liste, outM) THEN
		WriteString("Stringliste ok.");
		WriteLn();
	ELSE
		WriteString("Stringliste nicht ok. Irgendwo gibt es ein Problem !");
		StringAusgeben(outM);
	END;
	
	


END DruckTestStringliste.

