(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: AutoIMPORTE.mod,v $
# $Author: Sopra $	(Reini)
# $Date: 2001/01/14 10:46:14 $
# $Revision: 1.14 $
# Bemerkungen:
*)
(******************************************************************************)


IMPLEMENTATION MODULE AutoIMPORTE;


                       (* Datum.IstZeitraum1InZeitraum2 simulieren *)

  (*
  FROM Konden   IMPORT TKond, DisposeKond,  HoleGueltigeTKond, HoleGueltigeWKond,
                       LiesSTagInWKond,    LiesStdSinWKond;

  FROM HKe      IMPORT THK, TPersID, DisposeHK, FirstHK, NextHK, LiesPersIDHK;

  FROM VtrBez   IMPORT FirstValidVtrZuHKinZeitraum,  NextValidVtrZuHKinZeitraum,
                       FirstValidVtrZuHKinZeitpunkt, NextValidVtrZuHKinZeitpunkt,
                       FirstVtrzuHKinZeitpunkt,      NextVtrzuHKinZeitpunkt,
                       FirstVtrzuHKinZeitraum,       NextVtrzuHKinZeitraum,
		       FirstVtrZuHK,                 NextVtrZuHK,
                       FirstValidVtrZuHK,            NextValidVtrZuHK;

  FROM BelBez	IMPORT FirstBuZuKst,                 NextBuZuKst;

  FROM Vtre     IMPORT TVtr, DisposeVtr,       LiesGueltigVonInVtr,   LiesGueltigBisInVtr,
		       LiesStdzahlInVtr, VtrIDAlsString,        LiesVtrIDinVtr,
                       LiesKstIDinVtr;

  FROM Buen     IMPORT TBu,    CreateBu,      DisposeBu,              SetzeKstIDinBu,
                       SetzeVtrIDInBu,        SetzeBetragInBu,
                       SetzeGebuchtAmInBu,    SetzeBuchungsArtInBu,   InsertBu,
                       LiesKIDinKst,          SetzeLiquidAminKst,     LiesBetraginBu;

  FROM Ksten    IMPORT TKst, TKstID, DisposeKst,    LiesJahrInKst, KstIDAlsString,
                             FirstLfdKst,   NextLfdKst,    BerechneEtatKst,
                             SetzeLiquidAminKst, LiesKIDinKst;

  FROM VDruck	IMPORT Print;
*)
IMPORT Datum;
IMPORT Konden;
IMPORT HKe;
IMPORT VtrBez;
IMPORT BelBez;
IMPORT Vtre;
IMPORT Buen;
IMPORT Ksten;
IMPORT VDruck;
IMPORT String;

  (* -- FROM Bibliotheksmodul IMPORT CardAlsString; *)
(*
  TYPE  TDatum  = Datum.TDatum;
	TStag	= Datum.TStag;
	TJahr	= Datum.TJahr;
	TKond   = Konden.TKond;
	THK	= HKe.THK;
	TPersID = HKe.TPersID;
	TVtr	= Vtre.TVtr;
	TVtrID	= Vtre.TVtrID;
	TBu	= Buen.TBu;
	TBuArt	= Buen.TBuArt;
	TKst	= Ksten.TKst;
	TKstID	= Ksten.TKstID;
	TString	= String.TString;
  *)
(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
(* +             TS_Konden                                *)
(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE DispKond (VAR inoutKond : TKond);
BEGIN
	Konden.DisposeKond (inoutKond)
END DispKond;	


PROCEDURE HoleAktWKond(inDatum : TDatum; VAR outWKond : TKond) : BOOLEAN;
BEGIN
	RETURN Konden.HoleGueltigeWKond (inDatum, outWKond)
END HoleAktWKond;


PROCEDURE HoleAktTKond(inDatum : TDatum; VAR outTKond : TKond) : BOOLEAN;
BEGIN
	RETURN Konden.HoleGueltigeTKond (inDatum, outTKond)
END HoleAktTKond;


PROCEDURE LSTagDerWKond(inWKond : TKond) : TStag;
BEGIN
	RETURN Konden.LiesSTaginWKond (inWKond)
END LSTagDerWKond;


PROCEDURE LStdSinTKond(inTKond : TKond) : CARDINAL;
BEGIN
	RETURN Konden.LiesStdSinTKond (inTKond)
END LStdSinTKond;


PROCEDURE LBemMonatInWKond (inWKond : TKond) : TMonat;
BEGIN
	RETURN Konden.LiesBemMonatinWKond (inWKond)
END LBemMonatInWKond;

(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
(* +             TS_HKe                                   *)
(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE DispHK (VAR inoutHK : THK);
BEGIN
	HKe.DisposeHK (inoutHK)
END DispHK;


PROCEDURE ErsteHK(VAR outHK : THK) : BOOLEAN;
BEGIN
	RETURN HKe.FirstHK (outHK)
END ErsteHK;


PROCEDURE NaechsteHK(inoutHK : THK) : BOOLEAN;
BEGIN
	RETURN HKe.NextHK (inoutHK)
END NaechsteHK;


PROCEDURE LHKID(inHK : THK) : TPersID;
BEGIN
	RETURN HKe.LiesPersIDHK (inHK)
END LHKID;


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
(* +             FM_VtrBez                                *)
(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE FirstValVtrZuHKinZeitraum(inHKID : TPersID;
                 inAnfang, inEnde : TDatum; VAR outVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN VtrBez.FirstVldVtrZuHKinZtraum (inHKID, inAnfang, inEnde, outVtr)
END FirstValVtrZuHKinZeitraum;


PROCEDURE NextValVtrZuHKinZeitraum(inHKID : TPersID;
                 inAnfang, inEnde : TDatum; inoutVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN VtrBez.NextVldVtrZuHKinZtraum (inHKID, inAnfang, inEnde, inoutVtr)
END NextValVtrZuHKinZeitraum;


PROCEDURE FirstValVtrZuHKmitZeitpunkt(inHKID : TPersID;
                 inDatum : TDatum; VAR outVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN VtrBez.FirstVldVtrZuHKinZtpunkt (inHKID, inDatum, outVtr)
END FirstValVtrZuHKmitZeitpunkt;


PROCEDURE NextValVtrZuHKmitZeitpunkt(inHKID : TPersID;
                 inDatum : TDatum; inoutVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN VtrBez.NextVldVtrZuHKinZtpunkt (inHKID, inDatum, inoutVtr)
END NextValVtrZuHKmitZeitpunkt;


PROCEDURE FirstValVtrZuHK(inHKID : TPersID; VAR outVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN VtrBez.FirstValidVtrZuHK (inHKID, outVtr)
END FirstValVtrZuHK;


PROCEDURE NextValVtrZuHK(inHKID : TPersID; inoutVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN VtrBez.NextValidVtrZuHK (inHKID, inoutVtr)
END NextValVtrZuHK;


PROCEDURE FirstVtrZuHKmitZeitpunkt( inHKID : TPersID; inDatum : TDatum;
                                    VAR outVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN VtrBez.FirstVtrZuHKinZeitpunkt (inHKID, inDatum, outVtr)
END FirstVtrZuHKmitZeitpunkt;


PROCEDURE NextVtrZuHKmitZeitpunkt( inHKID : TPersID; inDatum : TDatum;
                                   inoutVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN VtrBez.NextVtrZuHKinZeitpunkt (inHKID, inDatum, inoutVtr)
END NextVtrZuHKmitZeitpunkt;


PROCEDURE FirstVtrZuHKinZraum (inHKID : TPersID; inAnfang,inEnde :TDatum;
                               VAR outVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN VtrBez.FirstVtrZuHKinZeitraum (inHKID, inAnfang, inEnde, outVtr)
END FirstVtrZuHKinZraum;


PROCEDURE NextVtrZuHKinZraum (inHKID : TPersID; inAnfang, inEnde : TDatum;
                              inoutVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN VtrBez.NextVtrZuHKinZeitraum (inHKID, inAnfang, inEnde, inoutVtr)
END NextVtrZuHKinZraum;


PROCEDURE ErsteVtrZuHK (inHKID : TPersID; VAR outVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN VtrBez.FirstVtrZuHK (inHKID, outVtr)
END ErsteVtrZuHK;


PROCEDURE NaechsteVtrZuHK (inHKID : TPersID; inoutVtr : TVtr) : BOOLEAN;
BEGIN
	RETURN VtrBez.NextVtrZuHK (inHKID, inoutVtr)
END NaechsteVtrZuHK;


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
(* +             FM_BelBez                                *)
(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE ErsteBuZuKst (inKstID : TKstID; VAR outBu : TBu) : BOOLEAN;
BEGIN
	RETURN BelBez.FirstBuZuKst (inKstID, outBu)
END ErsteBuZuKst;


PROCEDURE NaechsteBuZuKst (inKstID : TKstID; inoutBu : TBu) : BOOLEAN;
BEGIN
	RETURN BelBez.NextBuZuKst (inKstID, inoutBu)
END NaechsteBuZuKst;


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
(* +             TS_Vtre                                  *)
(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)

PROCEDURE DispVtr (VAR inoutVtr : TVtr);
BEGIN
	Vtre.DisposeVtr (inoutVtr)
END DispVtr;


PROCEDURE LGueltigVonInVtr (inVtr : TVtr) : TDatum;
BEGIN
	RETURN Vtre.LiesGueltigVoninVtr (inVtr)
END LGueltigVonInVtr;


PROCEDURE LGueltigBisInVtr (inVtr : TVtr) : TDatum;
BEGIN
	RETURN Vtre.LiesGueltigBisinVtr (inVtr)
END LGueltigBisInVtr;


PROCEDURE LStdZahlInVtr (inVtr : TVtr) : CARDINAL;
BEGIN
	RETURN Vtre.LiesStdzahlinVtr (inVtr)
END LStdZahlInVtr;


PROCEDURE LKstIDinVtr (inVtr : TVtr) : TKstID;
BEGIN
	RETURN Vtre.LiesKstIDinVtr (inVtr)
END LKstIDinVtr;


PROCEDURE LVtrIDinVtr (inVtr : TVtr) : TVtrID;
BEGIN
	RETURN Vtre.LiesVtrIDinVtr (inVtr)
END LVtrIDinVtr;


PROCEDURE LHKIDinVtr (inVtr : TVtr) : TPersID;
BEGIN
	RETURN Vtre.LiesPersIDinVtr (inVtr)
END LHKIDinVtr;


PROCEDURE VtrID2String (inVtrID : TVtrID) : TString;
BEGIN
	RETURN Vtre.VtrIDAlsString (inVtrID)
END VtrID2String;


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
(* +             TS_Buen                                  *)
(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE CreateBg() : TBu;
BEGIN
	RETURN Buen.CreateBu ()
END CreateBg;


PROCEDURE DispBu (VAR inoutBu : TBu);
BEGIN
	Buen.DisposeBu (inoutBu)
END DispBu;


PROCEDURE InsertBg (inBu : TBu; VAR outMessage : TString) : BOOLEAN;
BEGIN
	RETURN Buen.InsertBu (inBu, outMessage)
END InsertBg;


PROCEDURE SetKstIDinBu (inoutBu : TBu; inKstID : TKstID);
BEGIN
	Buen.SetzeKstIDinBu (inoutBu, inKstID)
END SetKstIDinBu;


PROCEDURE SetVtrIDinBu (inoutBu : TBu; inVtrID : TVtrID);
BEGIN
	Buen.SetzeVtrIDinBu (inoutBu, inVtrID)
END SetVtrIDinBu;


PROCEDURE LBetragInBu (inBu : TBu) : INTEGER;
BEGIN
	RETURN Buen.LiesBetraginBu (inBu)
END LBetragInBu;


PROCEDURE SetBetragInBu (inoutBu : TBu; inBetrag : INTEGER);
BEGIN
	Buen.SetzeBetraginBu (inoutBu, inBetrag)
END SetBetragInBu;


PROCEDURE SetGebuchtAmInBu (inoutBu : TBu; inGebuchtAm : TDatum);
BEGIN
	Buen.SetzeGebuchtAminBu (inoutBu, inGebuchtAm)
END SetGebuchtAmInBu;


PROCEDURE SetBuchungsArtInBu (inoutBu : TBu; inBuchungsArt : TBuArt);
BEGIN
	Buen.SetzeBuchungsArtinBu (inoutBu, inBuchungsArt)
END SetBuchungsArtInBu;


PROCEDURE BuStorniert (inBu : TBu) : BOOLEAN;
BEGIN
	RETURN Buen.IstStorniertinBu (inBu)
END BuStorniert;


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
(* +             TS_Ksten                                 *)
(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE DispKst (VAR inoutKst : TKst);
BEGIN
	Ksten.DisposeKst (inoutKst)
END DispKst;


PROCEDURE UpdateKst (inKst : TKst; VAR outMsg : TString) : BOOLEAN;
BEGIN
	RETURN Ksten.AendernKst (inKst, outMsg)
END UpdateKst;


PROCEDURE LJahrInKst ( inKst: TKst) : TJahr;
BEGIN
	RETURN Ksten.LiesJahrinKst (inKst)
END LJahrInKst;


PROCEDURE KstID2String ( inKstID : TKstID) : TString;
BEGIN
	RETURN Ksten.KstIDAlsString (inKstID)
END KstID2String;


PROCEDURE EtatDerKst (inKstID: TKstID): INTEGER;
BEGIN
	RETURN Ksten.BerechneEtatKst (inKstID)
END EtatDerKst;


PROCEDURE ErsteAktKst (VAR outKst : TKst) : BOOLEAN;
BEGIN
	RETURN Ksten.FirstAktKst (outKst)
END ErsteAktKst;


PROCEDURE NaechsteAktKst (inoutKst : TKst) : BOOLEAN;
BEGIN
	RETURN Ksten.NextAktKst (inoutKst)
END NaechsteAktKst;


PROCEDURE SetKstLiquAm (inoutKst : TKst; inDatum : TDatum);
BEGIN
	Ksten.SetzeLiquidAminKst (inoutKst, inDatum)
END SetKstLiquAm;


PROCEDURE LKIDinKst (inKst : TKst) : TKstID;
BEGIN
	RETURN Ksten.LiesKIDinKst (inKst)
END LKIDinKst;


(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)
(* +             TS_VDruck                                *)
(* ++++++++++++++++++++++++++++++++++++++++++++++++++++++ *)


PROCEDURE Druck ( inString : TString; outMsg : TString ) : BOOLEAN;
BEGIN
	RETURN VDruck.Print ( inString, outMsg)
END Druck;


(* -- es fehlen noch Konvertierungsroutinen 2String fuer den Druckauftrag *)
END AutoIMPORTE.