IMPLEMENTATION MODULE DialogLib;

IMPORT String;
IMPORT WholeStr;
FROM InOut IMPORT WriteString,WriteLn;
	
PROCEDURE DatumKorrekt(Eingabe : String.TString; VAR outMessage : String.TString) : BOOLEAN;
(*
Vb: --
berprft, ob das Char-Feld "inCHAR" ein gltiges Datum der Form "31.12.2001" ist
Das outMessage-ADO wird intern erzeugt.
Nb: --
*)

TYPE    CharArray = ARRAY[0..255] OF CHAR;
VAR 	
   Muster    : String.TString;
	Fehler    : BOOLEAN;
	err       : BOOLEAN;
	gefunden  : BOOLEAN;
	gueltig	 : BOOLEAN;
	alle3gueltig : BOOLEAN;
	posStart  : CARDINAL;
	posEnde   : CARDINAL;
	val	    : CARDINAL;
	i	       : CARDINAL;
	Result	 : WholeStr.ConvResults;


BEGIN
 (*Initialisierungen*)
 i := 0;
 posStart:=0;
 gueltig := TRUE;
 err  := FALSE;
 outMessage := String.Create();
 Muster :=String.Create();
 String.Schreibe(Muster,".");
 IF (String.Laenge(Eingabe) <> 10) THEN
  outMessage := String.Create();
  String.Schreibe(outMessage,"DialogLib:fehlerhafte Eingabe");
  err := TRUE;
 END;
 IF (err = FALSE) THEN
  REPEAT
    i := i+1;
    String.FindeNaechsten( Muster,Eingabe,posStart,gefunden,posEnde);
    IF NOT (gefunden AND (posEnde = posStart+2)) THEN
     err := TRUE;
     String.Schreibe(outMessage,"DialogLib:fehlerhafte Datumsstruktur");
    END;
    posStart := posEnde+1;
  UNTIL ((i = 2) OR (err = TRUE));
 END;
  IF (err = FALSE) THEN
   String.Schreibe(outMessage,"Datumsformat O.K");
  END;
  IF (err=TRUE) THEN
   String.Schreibe(outMessage,"Fehlerhaftes Datumsformat");
  END;
  RETURN NOT(err);
 END DatumKorrekt;
END DialogLib.



