(* Fernuni Hagen, Sopra WS2000/01   Autor: Christian Sonnweber *)


IMPLEMENTATION MODULE FLadenSysVw;

FROM SYSTEM    IMPORT  CAST, ADR, ADDRESS;
FROM X_Grafik  IMPORT  StelleListeDar,EntferneListe;
FROM X_Grafik  IMPORT  LiesListenelement, AendereListenelement;
FROM X_Grafik  IMPORT  StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik  IMPORT  StelleTextDar, EntferneText;
FROM X_Grafik  IMPORT  StelleMeldungDar, EntferneMeldung;
FROM X_Grafik  IMPORT  InitialisiereGrafik, StarteGrafik;
FROM X_Grafik  IMPORT  NeuesFenster, EntferneFenster;
FROM X_Grafik  IMPORT  MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik  IMPORT  StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik  IMPORT  StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik  IMPORT  EntferneKnopf, StelleKnopfDar;
FROM X_Grafik  IMPORT  LiesMenueEintrag, EntferneMenue;
FROM SYSTEM    IMPORT  CAST, ADR, ADDRESS;
FROM args      IMPORT  GetArgs, ArgTable;
FROM InOut     IMPORT  WriteString,WriteLn,WriteInt;
FROM DialogLib IMPORT  DatumKorrekt;

IMPORT  Datum;
IMPORT  Strings;
IMPORT  String;
IMPORT  Stringliste;
IMPORT  FLadenSysVw;
IMPORT  Adm;
IMPORT  SysDat;
IMPORT  Auto;
IMPORT  FSetDatumSysVw;


TYPE TActVater = PROCEDURE(  );
     TCharString = ARRAY[0..255] OF CHAR;

VAR
  FensterHandle		: ADDRESS;
  VaterFenster		: ADDRESS;
  Vater			: ADDRESS;
  EndeKnopfHandle	: ADDRESS;
  VersionListe		: ADDRESS;
  DatumFeldHandle	: ADDRESS;
  DatEingHelpMeldung	: ADDRESS;
  DefaultKnopf	        : ADDRESS;
  DatumMeldHdle   	: ADDRESS;
  MeldHandle1     	: ADDRESS;
  Meldung1		: ADDRESS;
  VersMeldHandle1 	: ADDRESS;
  VersMeldHandle2 	: ADDRESS;
  LadFertMeldHdle 	: ADDRESS;
  UpsMeldung      	: ADDRESS;
  SysDatListKnopf   	: ADDRESS;
  ShowSysDatKnopf   	: ADDRESS;
  ProblemMeld		: ADDRESS;
  NewBackup	    	: BOOLEAN;
  SysFenVisible     	: BOOLEAN;
  LadenNegativMeldHdle  : ADDRESS;
  SysDatListe           : ADDRESS;
  ShVSuccessMeld        : ADDRESS;
  RestoreMeld           : ADDRESS;
  LadenKnopf            : ADDRESS;
  Titel 		: String.TString;
  TextVonEingabe 	: String.TString;
  errmessg		: String.TString;
  ups	  		: String.TString;
  global_vers_string    : String.TString;
  global_liste_string   : String.TString;
  Ver			: SysDat.TVersion;
  SysGeladen            : BOOLEAN;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowSysDat(  );

VAR  Titel : String.TString;
     s             :  String.TString;
     s1						 :  String.TString;
     str1          :  String.TString;
     str2          :  String.TString;
     str3          :  String.TString;
     VersString    :  String.TString;
     Date          :  Datum.TDatum;
     Vers          :  SysDat.TVersion;
     Vers1	   :  SysDat.TVersion;
     StrListe      :  Stringliste.TStringliste;
BEGIN

   StrListe      :=  Stringliste.Create(  );
   s		 :=  String.Create(  );
   s1   	 :=  String.Create(  );
   str1          :=  String.Create(  );
   str2          :=  String.Create(  );
   str3          :=  String.Create(  );
   VersString    :=  String.Create(  );

   (*SysDat - Daten einlesen*)
   IF SysDat.FirstBackupInSysDat( Vers,Date ) THEN
      (* Erzeuge das Format: "1  12.02.53" fr die anschlieende Ausgabe in der Liste *)
     Stringliste.Insert( StrListe,ErzeugeAktVersionAlsString( Vers,Date ) );
     WHILE SysDat.NextBackupInSysDat( Vers,Date ) DO
       Stringliste.Insert( StrListe,ErzeugeAktVersionAlsString( Vers,Date ) );
     END;
   END;

   Date  := SysDat.LiesSystemDatumInSysDat(  );
   String.Schreibe( s1,StC( Datum.DatumAlsString( Date ) ) );
   String.Schreibe( s,"SystemDatum:  " );
   String.Anhaengen( s1,s );
   Stringliste.Insert( StrListe,s );

   Date  := SysDat.LiesLetztesAutoDatumInSysDat(  );
   String.Schreibe( s1,StC( Datum.DatumAlsString( Date ) ) );
   String.Schreibe( s,"Letzter AutoBetrieb:  " );
   String.Anhaengen( s1,s );
   Stringliste.Insert( StrListe,s );

(* ############################################################################################### *)
   Vers1 := SysDat.LiesBackupVersionInSysDat(  );
   s     := SysDat.VersionAlsString( Vers1 );
   WriteString( "Versionszhler:  " ); WriteString( StC( s ) );WriteLn(  );
   String.Schreibe( s1,"VersZaehler:  " );
   String.Anhaengen( s,s1 );
   Stringliste.Insert( StrListe,s1 );
(* ############################################################################################### *)

   String.Schreibe( s," SysDat - Inhalt" );
   SysDatListe := StelleListeDar( StrListe,s,6,FensterHandle,270,45,CAST( PROC,SysDatListeCallback ) );

   String.Dispose( s );
   String.Dispose( s1 );
   String.Dispose( str1 );
   String.Dispose( str2 );
   String.Dispose( str3 );
   String.Dispose( VersString );
   Stringliste.Dispose( StrListe );

END ShowSysDat;

(*----------------------------------------------------------------------------------------*)
PROCEDURE SysDatListeCallback(  );

BEGIN

END SysDatListeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE StC( inStr : String.TString ) : TCharString;
(*Umwandlung von TString nach Arrayof Char = TCharString*)

VAR outcharfeld : TCharString;

BEGIN

 String.Lies( inStr,outcharfeld );
 RETURN outcharfeld;

END StC;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ErzeugeKnoepfe(  );

VAR Titel : String.TString;

BEGIN

  Titel := String.Create(  );
  String.Schreibe( Titel,"SysDat - Liste neu lesen" );
  ShowSysDatKnopf := StelleKnopfDar( Titel,FensterHandle,275,220,CAST( PROC,ShowSysDatKnopfCallback ) );
  String.Schreibe( Titel,"Abbrechen" );
  EndeKnopfHandle := StelleKnopfDar( Titel,FensterHandle,275,320,CAST( PROC,EndeKnopfCallback ) );
  String.Schreibe( Titel,"Version laden" );
  LadenKnopf      := StelleKnopfDar( Titel,FensterHandle,70,280,CAST( PROC,LadenCallback ) );
  String.Schreibe( Titel,"Defaultwerte laden" );
  DefaultKnopf    := StelleKnopfDar( Titel,FensterHandle,275,280,CAST( PROC,LadeDefaultWerteCallback ) );
  String.Dispose( Titel );

END ErzeugeKnoepfe;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowSysDatKnopfCallback(  );

BEGIN

  IF SysFenVisible THEN
   ShowSysDat(  );
  ELSE
   EntferneListe( SysDatListe );
  END;

  SysFenVisible := NOT SysFenVisible;

END ShowSysDatKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE EndeKnopfCallback(  );

VAR    AktiviereVater : TActVater;

BEGIN

  WriteString( "EndeKnopfCallback" );WriteLn(  );
  EntferneFenster( FensterHandle );
  WriteString( "EndeKnopfCallback.EntferneFenster" );WriteLn(  );
  AktiviereVater := CAST( TActVater,Vater );    (*Casting von ADDRESS nach TActVater. TActVater ist paremterlose Funktion*)
  WriteString( "EndeKnopfCallback.AktiviereVater" );WriteLn(  );
  AktiviereVater(  );                           (* Reaktiviere das Hauptfenster *)

END EndeKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ShowVersions(  );

VAR  StrLst        :  Stringliste.TStringliste;
     s             :  String.TString;
     str1          :  String.TString;
     str2          :  String.TString;
     str3          :  String.TString;
     VersString    :  String.TString;
     Date          :  Datum.TDatum;
     Vers	   :  SysDat.TVersion;
     ErrMsg        :  String.TString;

BEGIN

    s		   :=  String.Create(  );
    str1           :=  String.Create(  );
    str2           :=  String.Create(  );
    str3           :=  String.Create(  );
    VersString     :=  String.Create(  );

 (*SysDat - Daten einlesen*)
   IF SysDat.FirstBackupInSysDat( Vers,Date ) THEN
      StrLst        :=  Stringliste.Create(  );
      Stringliste.Insert( StrLst,ErzeugeAktVersionAlsString( Vers,Date ) );
      WHILE SysDat.NextBackupInSysDat( Vers,Date ) DO
       Stringliste.Insert( StrLst,ErzeugeAktVersionAlsString( Vers,Date ) );
      END;
      String.Schreibe( s,"Vers.   Datum" );
      VersionListe := StelleListeDar( StrLst,s,9,FensterHandle,60,45,CAST( PROC,VersionListeCallback ) );
      Stringliste.Dispose( StrLst );
   END;

   (* Aufrumen *)
   String.Dispose( s );
   String.Dispose( str1 );
   String.Dispose( str2 );
   String.Dispose( str3 );
   String.Dispose( VersString );

END ShowVersions;
(*----------------------------------------------------------------------------------------*)

PROCEDURE VersionListeCallback( element : INTEGER );

BEGIN

  LiesListenelement( VersionListe,element,global_liste_string );

  String.Auslesen( global_liste_string,0,1,global_vers_string );

END VersionListeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE LadenCallback(  );

VAR Titel   : String.TString;
    err     : String.TString;
    tests   : String.TString;
    messg   : String.TString;
    errmsg  : String.TString;
    success : BOOLEAN;
    AutIsRun: ADDRESS;
BEGIN

  EntferneKnopf( DefaultKnopf );
  EntferneListe( VersionListe );

  success := FALSE;
  Titel   := String.Create(  );
  err     := NIL;

  (*TVersion erzeugen*)
  IF SysDat.VersionVonString ( global_vers_string,Ver,err ) THEN
    Titel := String.Create(  );
    String.Schreibe( Titel, " Version" );
    ProblemMeld     :=  StelleMeldungDar( Titel,TRUE,FensterHandle,120,60 );
    VersMeldHandle2 :=  StelleMeldungDar( global_liste_string,FALSE,FensterHandle,110,75 );

    success := Adm.RestoreSystemInAdm( Ver,errmsg );

  IF NOT success THEN
       errmsg := String.Create(  );
       String.Schreibe( errmsg,"Systemfehler" );
       MeldungAnzeigen( errmsg );
       String.Dispose(  errmsg );
  ELSE
     messg  := String.Create(  );
     String.Schreibe( messg,"System erfolgreich geladen" );
     ShVSuccessMeld := StelleMeldungDar( messg,TRUE,FensterHandle,60,110 );

     (*AutoBetrieb starten*)
     AutoBetriebStart(  );

     FSetDatumSysVw.SetAutoBetriebAktiv(  );
     SysGeladen := TRUE;

   END;
    (*EntferneMeldung(AutIsRun);*)  END;

END LadenCallback;

(*----------------------------------------------------------------------------------------*)


PROCEDURE InitialDialog(  ) : BOOLEAN;

VAR ErrMsg     : String.TString;
    Vers       : SysDat.TVersion;
    Date       : Datum.TDatum;
    existversions  :  BOOLEAN;

BEGIN
       (*SysDat als Liste darstellen*)
   IF SysDat.FirstBackupInSysDat( Vers,Date ) THEN
     existversions := TRUE;
     Datum.DisposeDatum( Date );
     SysDat.DisposeVersionInSysDat( Vers );
   ELSE
     existversions:= FALSE;
     ErrMsg := String.Create(  );
     String.Schreibe( ErrMsg,"Keine Daten vorhanden, es wird mit den Standardwerten gearbeitet " );
     MeldungAnzeigen( ErrMsg );
     SysGeladen := TRUE;
     String.Dispose( ErrMsg );
     EndeKnopfCallback(  );
   END;
   RETURN existversions;

END InitialDialog;


(*----------------------------------------------------------------------------------------*)

PROCEDURE LadeDefaultWerteCallback(  );

VAR ok : BOOLEAN;
    errmsg : String.TString;
    text   : String.TString;
    vers   : SysDat.TVersion;
BEGIN

   text := String.Create(  );
   String.Schreibe( text,"0" );
   IF  SysDat.VersionVonString( text,vers,errmsg ) THEN
    IF NOT Adm.InitSystemInAdm( vers,errmsg ) THEN
     MeldungAnzeigen( errmsg );
     String.Dispose( errmsg );
    ELSE
     text := String.Create(  );
     String.Schreibe( text,"System mit Standardwerten initialisiert" );
     MeldungAnzeigen( text );
     SysGeladen := TRUE;
    END;
     SysDat.DisposeVersionInSysDat( vers );
    ELSE
     String.Schreibe( text,"OOPS!!!" );
     HALT;
    END;

END LadeDefaultWerteCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ErzeugeAktVersionAlsString( inVers : SysDat.TVersion;inDatum : Datum.TDatum ):String.TString;
(*
Erzeugt einen String.TString bestehend Inhalten von inVers plus inDatum
*)
VAR str1  : String.TString;
    str2  : String.TString;
    str3  : String.TString;

BEGIN
   str1 := String.Create(  );
   str2 := String.Create(  );
   str3 := String.Create(  );
   str1 := SysDat.VersionAlsString( inVers );
   str2 := Datum.DatumAlsString( inDatum );
   (* Erzeuge das Format: "1  12.02.53" fr die anschlieende Ausgabe in der Liste *)
   String.Schreibe( str3,"  " );
   String.Anhaengen( str3,str1 );
   String.Anhaengen( str2,str1 );
   (* Aufrumen*)
   String.Dispose( str2 );
   String.Dispose( str3 );
   RETURN str1;

END ErzeugeAktVersionAlsString;
(*----------------------------------------------------------------------------------------*)

PROCEDURE AutoBetriebStart(  );
VAR 	Titel,messg		: String.TString;
	LetztesAutoDatum	: Datum.TDatum;
	AktDatum		: Datum.TDatum;
        AutoBetrMeld            : ADDRESS;
BEGIN

  LetztesAutoDatum:=SysDat.LiesLetztesAutoDatumInSysDat(  );
  AktDatum:=SysDat.LiesSystemDatumInSysDat(  );

  (*AutoBetrieb ausfhren *)
  messg := String.Create();
  String.Schreibe(messg,"Autobetrieb wird ausgefhrt!!");
  AutoBetrMeld := StelleMeldungDar( messg,TRUE,FensterHandle,70,300 );
  Auto.NachziehenAutoBuen( LetztesAutoDatum,AktDatum );
  EntferneMeldung(AutoBetrMeld);

  (* SysDatEintragungen vornehmen *)
  SysDat.SetzeLetztesAutoDatumInSysDat( AktDatum );
  Datum.DisposeDatum( AktDatum );
  Datum.DisposeDatum( LetztesAutoDatum );
  Titel := String.Create(  );
  String.Schreibe( Titel,"Autobetrieb beendet" );
  Meldung1 := StelleMeldungDar( Titel,TRUE,FensterHandle,90,150 );
  String.Dispose( Titel );
  EntferneMeldung( VersMeldHandle1 );

END AutoBetriebStart;

(*------------------------------------------------------------------------------------------*)
PROCEDURE SystemGeladen( ) : BOOLEAN;
(*
   -- Liefert dem Hauptprogramm die Information, ob das System erfolgreich geladen wurden
   -- Die Funktion wird im Zusammenhang der Steuerung der Zustandsuebergaenge aufgerufen.
*)

BEGIN

  RETURN SysGeladen;

END SystemGeladen;

(*------------------------------------------------------------------------------------------*)

PROCEDURE Create( inFunct : ADDRESS );
VAR Titel  : String.TString;
    ErrMsg : String.TString;
BEGIN
  InitializeVars(  );
  Vater := inFunct;
  IF InitialDialog(  ) THEN
    Titel := String.Create(  );
    String.Schreibe( Titel,"hiks.Systemverwaltung.SystemLaden" );
    FensterHandle :=  NeuesFenster( Titel,170,160,380,585 );
    ErzeugeKnoepfe(  );
    ShowVersions(  );
    ShowSysDat(  );
    String.Dispose( Titel );
  END;
END Create;

(*------------------------------------------------------------------------------------------*)

PROCEDURE InitializeVars(  );
BEGIN
  global_vers_string    := String.Create(  );
  global_liste_string   := String.Create(  );
  FensterHandle	        := NIL;
  VaterFenster		:= NIL;
  Vater			:= NIL;
  EndeKnopfHandle	:= NIL;
  VersionListe		:= NIL;
  DatumFeldHandle	:= NIL;
  DatEingHelpMeldung	:= NIL;
  DefaultKnopf	        := NIL;
  DatumMeldHdle   	:= NIL;
  MeldHandle1     	:= NIL;
  Meldung1		:= NIL;
  VersMeldHandle1 	:= NIL;
  VersMeldHandle2 	:= NIL;
  LadFertMeldHdle 	:= NIL;
  UpsMeldung      	:= NIL;
  SysDatListe   	:= NIL;
  ShowSysDatKnopf   	:= NIL;
  Titel 		:= NIL;
  TextVonEingabe 	:= NIL;
  errmessg		:= NIL;
  ups	  		:= NIL;
  NewBackup	    	:= FALSE;
  SysFenVisible     	:= FALSE;
END InitializeVars;
(*------------------------------------------------------------------------------------------*)

BEGIN

 SysGeladen := FALSE;

END FLadenSysVw.
