IMPLEMENTATION MODULE FSetDatumSysVw;

FROM SYSTEM    IMPORT CAST, ADR, ADDRESS;
FROM X_Grafik  IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik  IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik  IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik  IMPORT StelleTextDar, EntferneText;
FROM X_Grafik  IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik  IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik  IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik  IMPORT MeldungAnzeigen,JaNeinAbfrage;
FROM X_Grafik  IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik  IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik  IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik  IMPORT LiesMenueEintrag, EntferneMenue;
FROM SYSTEM    IMPORT CAST, ADR, ADDRESS;
FROM args      IMPORT GetArgs, ArgTable;
FROM InOut     IMPORT WriteString,WriteLn,WriteInt;
FROM DialogLib IMPORT DatumKorrekt;

IMPORT Datum;
IMPORT Strings;
IMPORT String;
IMPORT Stringliste;
IMPORT SysDat;
IMPORT Adm;


VAR

  FensterHandle		: ADDRESS;
  VaterFenster		: ADDRESS;
  Vater			: ADDRESS;
  EndeKnopfHandle	: ADDRESS;
  DatumFeldHandle	: ADDRESS;
  DatEingHelpMeldung	: ADDRESS;
  UpsMeldung            : ADDRESS;
  AutoBetrKnopfHandle   : ADDRESS;
  AutoEndeMeldHandle	: ADDRESS;
  DatOkKnopfHandle  	: ADDRESS;
  VersInfoMeldHdle1     : ADDRESS;
  VersInfoMeldHdle2     : ADDRESS;
  DatumString           : String.TString;
  inTitel 		: String.TString;
  error			: String.TString;
  ups                   : String.TString;
  errmessg		: String.TString;
  MeldHandle1           : ADDRESS;
  MeldHandle2	        : ADDRESS;



TYPE TActVater = PROCEDURE();
     TCharString = ARRAY[0..255] OF CHAR;


(*----------------------------------------------------------------------------------------*)

PROCEDURE StC(inStr : String.TString) : TCharString;
(*Umwandlung von TString nach Arrayof Char = TCharString*)
VAR outcharfeld : TCharString;
BEGIN
 String.Lies(inStr,outcharfeld);
 RETURN outcharfeld;
END StC;

(*----------------------------------------------------------------------------------------*)

PROCEDURE ErzeugeKnoepfe();
VAR Titel : String.TString;
BEGIN
  Titel := String.Create();
  String.Schreibe(Titel,"Abbrechen");
  EndeKnopfHandle := StelleKnopfDar(Titel,FensterHandle,250,280,CAST(PROC,EndeKnopfCallback));
END ErzeugeKnoepfe;

(*----------------------------------------------------------------------------------------*)


PROCEDURE EndeKnopfCallback();
VAR Abfragetext : String.TString;
BEGIN
  Abfragetext := String.Create();
  String.Schreibe(Abfragetext,"Wirklich beenden?");
  EntferneKnopf(EndeKnopfHandle);
  EntferneFenster(FensterHandle);
  Dispose();
END EndeKnopfCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE MaskeDatumEingabe;
VAR Titel,Text : String.TString;
    inSpalten,inXPosition,inYPosition : INTEGER;

BEGIN
   Titel := String.Create();
   String.Schreibe(Titel,"Aktuelle Version");
   VersInfoMeldHdle1 :=  StelleMeldungDar(Titel,TRUE,FensterHandle,240,50);
   String.Schreibe(Titel,"VersInfo aus SysDatADO");
   VersInfoMeldHdle2 :=  StelleMeldungDar(Titel,FALSE,FensterHandle,225,70);

   String.Schreibe(Titel,"Neues SystemDatum eingeben: ");
   Text := String.Create();
   String.Schreibe(Text,"");
   DatumFeldHandle := StelleZeileDar(Titel,Text,10,FensterHandle,30,150);

   String.Schreibe(Titel,"(DD.MM.JJJJ)");
   DatEingHelpMeldung := StelleMeldungDar(Titel,FALSE,FensterHandle,255,170);

   String.Schreibe(Titel,"---> Eingabe besttigen");
   DatOkKnopfHandle := StelleKnopfDar(Titel,FensterHandle,400,150,CAST(PROC,DatumEingabeCallback));
   String.Dispose(Titel);
   String.Dispose(Text);
END MaskeDatumEingabe;

(*----------------------------------------------------------------------------------------*)

PROCEDURE DatumEingabeCallback();
VAR
   ok            : BOOLEAN;
   ok1			  : BOOLEAN;
   dat           : Datum.TDatum;

BEGIN
  ok  := FALSE;
  ok1 := FALSE;
  DatumString := String.Create();
  LiesZeile(DatumFeldHandle,DatumString);

  WriteString(StC(DatumString));WriteLn;

  ok1 := DatumKorrekt(DatumString,errmessg);
  IF ok1 THEN
   ok :=  Datum.DatumVonString ( DatumString, dat, error );
   IF ok  THEN
    (*enferne Fehlermeldung bei vorhergegangenem Datumsfehler*)
    IF NOT(UpsMeldung=NIL) THEN
     EntferneMeldung(UpsMeldung);
     UpsMeldung := NIL;
    END;

    (* Schreibe das neue Systemdatum ins SysDat - ADO *)
    SysDat.SetzeSystemDatumInSysDat(dat);
    (* Baue neue Maske auf *)
    EntferneZeile(DatumFeldHandle);
    EntferneMeldung(DatEingHelpMeldung);
    EntferneKnopf(DatOkKnopfHandle);
    inTitel := String.Create();
    String.Schreibe(inTitel,"SystemDatum");
    MeldHandle1 := StelleMeldungDar(inTitel,TRUE,FensterHandle,240,140);
    MeldHandle2 := StelleMeldungDar(DatumString,FALSE,FensterHandle,250,160);
    String.Schreibe(inTitel," >>  Automatikbetrieb Starten  <<");
    AutoBetrKnopfHandle := StelleKnopfDar(inTitel,FensterHandle,180,230,CAST(PROC,AutBetrKnHdleCallback));
  END;
 END;

 IF NOT(ok AND ok1) THEN
   IF NOT(UpsMeldung=NIL) THEN
     EntferneMeldung(UpsMeldung);
     UpsMeldung := NIL;
   END;
   ups := String.Create();
   String.Schreibe(ups,"U  U U UPS!!!");
   UpsMeldung := StelleMeldungDar(ups,TRUE,FensterHandle,250,120);
 END;

 IF ok AND ok1 THEN
  IF NOT (inTitel = NIL) THEN
    String.Dispose(inTitel);
    inTitel := NIL;
  END;

  IF NOT(UpsMeldung=NIL) THEN
    EntferneMeldung(UpsMeldung);
    UpsMeldung := NIL;
  END;

  IF NOT(DatumString=NIL) THEN
    String.Dispose(DatumString);
    DatumString:=NIL;
  END;
 END;
END DatumEingabeCallback;

(*----------------------------------------------------------------------------------------*)

PROCEDURE AutBetrKnHdleCallback;
(* Durchfhrung des Automatischen Betriebes --> TS_ADM *)
VAR Titel : String.TString;
BEGIN
  IF NOT(UpsMeldung=NIL) THEN
    EntferneMeldung(UpsMeldung);
    UpsMeldung := NIL;
  END;
  EntferneKnopf(AutoBetrKnopfHandle);
  AutoBetrKnopfHandle:=NIL;
  Titel := String.Create();
  String.Schreibe(Titel,"Auto - Betrieb beendet");
  AutoEndeMeldHandle := StelleMeldungDar(Titel,TRUE,FensterHandle,210,210);
END AutBetrKnHdleCallback;


(*----------------------------------------------------------------------------------------*)

PROCEDURE Create(inFunct : ADDRESS);
VAR Titel : String.TString;
BEGIN
 Vater := inFunct;
 Titel := String.Create();
 String.Schreibe(Titel,"hiks.Systemverwaltung.DatumEingeben");
 FensterHandle :=  NeuesFenster( Titel,170,200,350,600);
 ErzeugeKnoepfe();
 MaskeDatumEingabe();
END Create;
(*----------------------------------------------------------------------------------------*)

PROCEDURE Dispose();
VAR AktiviereVater : TActVater;
BEGIN
 EntferneKnopf(EndeKnopfHandle);
 EntferneFenster(FensterHandle);
 AktiviereVater := CAST(TActVater,Vater);
 AktiviereVater();
END Dispose;
(*----------------------------------------------------------------------------------------*)

BEGIN
  ups           := NIL;
  UpsMeldung    := NIL;
  inTitel       := NIL;
  DatumString   := NIL;
END FSetDatumSysVw.
