(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile$
# $Author$
# $Date$
# $Revision$
# Bemerkungen:

MODULE mainjzpsb;

JZ

*)
(******************************************************************************)

MODULE mainjzpsb;

FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT CAST, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE;
FROM args IMPORT GetArgs, ArgTable;
IMPORT String; 
FROM InOut IMPORT WriteCard, WriteLn, WriteString, WriteInt;

FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
(* FROM FAnlegenKst IMPORT CreateFAnlegen; *) 
IMPORT FAnlegenKst;
IMPORT FSelBeaKst;
IMPORT FSelBeKstT;
IMPORT FSelBuKst;
IMPORT FSelBuKstT;
IMPORT FKondWkEin;
IMPORT FKondWkAnz;
IMPORT FKondTkEin;
IMPORT FKondVtrEin;
IMPORT FKondTkAnz;
IMPORT FKondVtrAnz;


  TYPE 	TFMainDS = RECORD
		     WinHdle : ADDRESS;
    EndeKnopfHdle,
    FAnlegenKstKnopfHdle,
    FSelektionBuKstKnopfHdle,
    FSelektionBuKstTKnopfHdle,
    FSelektionBearbKstKnopfHdle,
    FSelektionBearbKstTKnopfHdle,
    FKondWkEinKnopfHdle,
    FKondTkEinKnopfHdle,
    FKondVtrEinKnopfHdle,
    FKondWkAnzKnopfHdle,
    FKondTkAnzKnopfHdle,
    FKondVtrAnzKnopfHdle,
   		     MeldHdle: ADDRESS;	
		   END;	 (* und deren Elemente *)
       	TPFMain = POINTER TO TFMainDS;

  VAR
     HauptfensterHdle: ADDRESS;
     Args    : ArgTable;
     AnzArgs : CARDINAL;
     ichSelbst: TPFMain; (* Zeiger auf ADT Fenster Main *)
     meineAddr: ADDRESS; (* Addresse dazu *)

(* --------------------------------------------------------------- *)

PROCEDURE AktivFMain();
  VAR
    Text       : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFMain;
  BEGIN
    (* Erzeuge den Fensterinhalt *)

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFMain, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren (Meiner Meinung nach fr Hauptfenster nicht notwendig, da ohnehin
       hier eine globale Variable gesetzt ist; jedoch bei allen anderen ADT's notwendig) *)


    Text := String.Create();
    String.Schreibe(Text,"Test-Grabo zum Personalsachbeauftragten PSB");
    ichSelbst^.MeldHdle:=StelleMeldungDar(Text,TRUE,ichSelbst^.WinHdle,10,10);


    String.Schreibe(Text,"Ende");
    ichSelbst^.EndeKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,10,70,CAST(PROC,EndeKnopfCallback));

    String.Schreibe(Text,"Kostenstelle anlegen");
    ichSelbst^.FAnlegenKstKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,100,70,CAST(PROC,FAnlegenKstKnopfCallback));

    String.Schreibe(Text,"Kostenstelle bearbeiten");
    ichSelbst^.FSelektionBearbKstKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,100,100,CAST(PROC,FSelektionBearbKstKnopfCallback));

    String.Schreibe(Text,"Kostenstelle buchen");
    ichSelbst^.FSelektionBuKstKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,100,130,CAST(PROC,FSelektionBuKstKnopfCallback));

    String.Schreibe(Text,"Weihnachtsgeldkondition einfuegen");
    ichSelbst^.FKondWkEinKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,100,160,CAST(PROC,FKondWkEinKnopfCallback));

    String.Schreibe(Text,"gueltige Weihnachtsgeldkondition anzeigen");
    ichSelbst^.FKondWkAnzKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,100,190,CAST(PROC,FKondWkAnzKnopfCallback));

    String.Schreibe(Text,"Tarifkondition einfuegen");
    ichSelbst^.FKondTkEinKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,100,220,CAST(PROC,FKondTkEinKnopfCallback));

    String.Schreibe(Text,"gueltige Tarifkondition anzeigen");
    ichSelbst^.FKondTkAnzKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,100,250,CAST(PROC,FKondTkAnzKnopfCallback));

    String.Schreibe(Text,"Vetragskondition einfuegen");
    ichSelbst^.FKondVtrEinKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,100,280,CAST(PROC,FKondVtrEinKnopfCallback));

    String.Schreibe(Text,"gueltige Vertragskondition anzeigen");
    ichSelbst^.FKondVtrAnzKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,100,310,CAST(PROC,FKondVtrAnzKnopfCallback));

(*
    String.Schreibe(Text,"");
    ichSelbst^.FSelektionBearbKstTKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,100,340,CAST(PROC,FSelektionBearbKstTKnopfCallback));

    String.Schreibe(Text,"");
    ichSelbst^.FSelektionBuKstTKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,100,370,CAST(PROC,FSelektionBuKstTKnopfCallback));
*)

    String.Dispose(Text);

  END AktivFMain;


PROCEDURE EndeKnopfCallback();
  BEGIN
    DisposeFMain();
  END EndeKnopfCallback;

PROCEDURE FAnlegenKstKnopfCallback();
  BEGIN
    DeaktFMain();
    FAnlegenKst.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FAnlegenKstKnopfCallback;

PROCEDURE FSelektionBuKstKnopfCallback();
  BEGIN
    DeaktFMain();
    FSelBuKst.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FSelektionBuKstKnopfCallback;

PROCEDURE FSelektionBuKstTKnopfCallback();
  BEGIN
    DeaktFMain();
    FSelBuKstT.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FSelektionBuKstTKnopfCallback;

PROCEDURE FSelektionBearbKstKnopfCallback();
  BEGIN
    DeaktFMain();
    FSelBeaKst.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FSelektionBearbKstKnopfCallback;

PROCEDURE FKondWkEinKnopfCallback();
  BEGIN
    DeaktFMain();
    FKondWkEin.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FKondWkEinKnopfCallback;

PROCEDURE FKondWkAnzKnopfCallback();
  BEGIN
    DeaktFMain();
    FKondWkAnz.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FKondWkAnzKnopfCallback;

PROCEDURE FKondTkEinKnopfCallback();
  BEGIN
    DeaktFMain();
    FKondTkEin.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FKondTkEinKnopfCallback;

PROCEDURE FKondVtrEinKnopfCallback();
  BEGIN
    DeaktFMain();
    FKondVtrEin.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FKondVtrEinKnopfCallback;

PROCEDURE FKondTkAnzKnopfCallback();
  BEGIN
    DeaktFMain();
    FKondTkAnz.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FKondTkAnzKnopfCallback;

PROCEDURE FKondVtrAnzKnopfCallback();
  BEGIN
    DeaktFMain();
    FKondVtrAnz.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FKondVtrAnzKnopfCallback;


PROCEDURE FSelektionBearbKstTKnopfCallback();
  BEGIN
    DeaktFMain();
    FSelBeKstT.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FSelektionBearbKstTKnopfCallback;



PROCEDURE DisposeFMain();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFMain;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFMain, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren (Meiner Meinung nach fr Hauptfenster nicht notwendig, da ohnehin
       hier eine globale Variable gesetzt ist; jedoch bei allen anderen ADT's notwendig) *)

    EntferneFenster(ichSelbst^.WinHdle);
    Pop();
    (* Lschen des letzten Stapeleintrages *)
  END DisposeFMain;

PROCEDURE DeaktFMain();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFMain;
  BEGIN
    IF TRACE THEN WriteString("mainjz.DeaktFMain Begin"); WriteLn; END;
    (*Deaktiviere Knpfe, Listboxen,... *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFMain, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren (Meiner Meinung nach fr Hauptfenster nicht notwendig, da ohnehin
       hier eine globale Variable gesetzt ist; jedoch bei allen anderen ADT's notwendig) *)

    SetzeKnopf(ichSelbst^.EndeKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FAnlegenKstKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FSelektionBuKstKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FSelektionBearbKstKnopfHdle, FALSE);

(*  SetzeKnopf(ichSelbst^.FSelektionBearbKstTKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FSelektionBuKstTKnopfHdle, FALSE);   *)

    SetzeKnopf(ichSelbst^.FKondWkEinKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FKondTkEinKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FKondVtrEinKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FKondWkAnzKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FKondTkAnzKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FKondVtrAnzKnopfHdle, FALSE);
    (* Elemente deaktivieren *)

    IF TRACE THEN WriteString("mainjz.DeaktFMain End"); WriteLn; END;
  END DeaktFMain;

PROCEDURE ReaktFMain();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFMain;
  BEGIN
    IF TRACE THEN WriteString("mainjz.RaktFMain Begin"); WriteLn; END;
   (* Aktiviere alle Fensterinhalte *)
   Top(reaktProc, meineAddr);
   ichSelbst:= CAST(TPFMain, meineAddr);
   (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren *)

    SetzeKnopf(ichSelbst^.EndeKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FAnlegenKstKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FSelektionBuKstKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FSelektionBearbKstKnopfHdle, TRUE);

(*  SetzeKnopf(ichSelbst^.FSelektionBearbKstTKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FSelektionBuKstTKnopfHdle, TRUE);    *)

    SetzeKnopf(ichSelbst^.FKondWkEinKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FKondTkEinKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FKondVtrEinKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FKondWkAnzKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FKondTkAnzKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FKondVtrAnzKnopfHdle, TRUE);

   (* Elemente aktivieren *)
   IF TRACE THEN WriteString("mainjz.RaktFMain End"); WriteLn; END;
  END ReaktFMain;



CONST
  TRACE=FALSE;
BEGIN

  GetArgs (AnzArgs,Args);
  HauptfensterHdle := InitialisiereGrafik(AnzArgs,Args,10,10,400,500);
  (* Addresse des Fensterrahmens bestimmen *)

  NEW (ichSelbst);
  (* Speicherplatz fr den "ADT Fenster Main" reservieren *)
  meineAddr:= CAST(ADDRESS, ichSelbst);
  (* Zeiger auf die Addresse des "ADT Fenster Main" bestimmen *)
  Push(ReaktFMain, meineAddr);
  (* Reaktivierungsprozedur des "ADT Fenster Main" und dessen Addresszeiger auf Stapel legen *)

  ichSelbst^.WinHdle:= HauptfensterHdle;
  (* Addresszeiger des Fensterrahmens im "ADT Fenster Main" eintragen *)

  AktivFMain();
  (* Prozedure zum Aufbauen des Fensterinhaltes aufrufen *)

  StarteGrafik();
END mainjzpsb.
