(******************************************************************************)
(*                         -> Sopra WS2000/2001 <-                            *)
(*                   Hilfskraftinformations-System 'HiKS'                     *)
(*
# $RCSfile: mainpsb.mod,v $
# $Author: Sopra $
# $Date: 2001/03/13 16:57:02 $
# $Revision: 1.14 $
# Bemerkungen:

MODULE mainpsb;

JZ

*)
(******************************************************************************)


MODULE mainpsb;

FROM X_Grafik IMPORT StelleListeDar,EntferneListe;
FROM X_Grafik IMPORT LiesListenelement, AendereListenelement;
FROM X_Grafik IMPORT StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM X_Grafik IMPORT StelleTextDar, EntferneText;
FROM X_Grafik IMPORT StelleMeldungDar, EntferneMeldung;
FROM X_Grafik IMPORT InitialisiereGrafik, StarteGrafik;
FROM X_Grafik IMPORT NeuesFenster, EntferneFenster;
FROM X_Grafik IMPORT MeldungAnzeigen, JaNeinAbfrage;
FROM X_Grafik IMPORT StringEingabeFenster, StringEingabeAuslesen;
FROM X_Grafik IMPORT StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM X_Grafik IMPORT StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM X_Grafik IMPORT LiesMenueEintrag, EntferneMenue;

FROM SYSTEM IMPORT CAST, ADDRESS, TSIZE;
FROM Storage IMPORT ALLOCATE;
FROM args IMPORT GetArgs, ArgTable;
IMPORT String; 
IMPORT Stringliste;

FROM InOut IMPORT WriteCard, WriteLn, WriteString, WriteInt;

IMPORT Datum;
IMPORT SysDat;
IMPORT Adm;
FROM SysReaktFStapel IMPORT Push, Pop, Top, TProc;
(* FROM FAnlegenKst IMPORT CreateFAnlegen; *) 
IMPORT FAnlegenKst;
IMPORT FSelBeaKst;
IMPORT FSelBuKst;
IMPORT FKondWkEin;
IMPORT FKondWkAnz;
IMPORT FKondTkEin;
IMPORT FKondVtrEin;
IMPORT FKondTkAnz;
IMPORT FKondVtrAnz;
IMPORT FListBox;
IMPORT FSysDatEin;
IMPORT FAutDatEin;
IMPORT FSysVarAnz;
IMPORT FSelResVer;
IMPORT FInfo;
IMPORT FAnlegenHK;
IMPORT FSelektionHK;
IMPORT FAnlegenVtrHKB;
IMPORT FAendernVtrHKB;
IMPORT Auto;



  TYPE 	TFMainDS = RECORD
		     	WinHdle : ADDRESS;
			EndeKnopfHdle,
    			FAnlegenKstKnopfHdle,
    			FSelektionBuKstKnopfHdle,
    			FSelektionBuKstTKnopfHdle,
    			FSelektionBearbKstKnopfHdle,
    			FSelektionBearbKstTKnopfHdle,
    			FKondWkEinKnopfHdle,
    			FKondTkEinKnopfHdle,
    			FKondVtrEinKnopfHdle,
    			FKondWkAnzKnopfHdle,
    			FKondTkAnzKnopfHdle,
    			FKondVtrAnzKnopfHdle,
    			FListBoxKnopfHdle,
    			FSysDatEinKnopfHdle,
    			FAutoDatEinKnopfHdle,
    			FSysVarAnzKnopfHdle,
    			FSelResVerKnopfHdle,
    			FInfoKnopfHdle,
    			BackupKnopfHdle,
    			FAnlegenHKKnopfHdle,
    			FSelektionHKKnopfHdle,
    			FAnlegenVtrHKBKnopfHdle,
    			FAendernVtrHKBKnopfHdle,
    			AutoBetriebKnopfHdle,
   		     MeldHdle: ADDRESS;	
		   END;	 (* und deren Elemente *)
       	TPFMain = POINTER TO TFMainDS;

  VAR
     HauptfensterHdle: ADDRESS;
     Args    : ArgTable;
     AnzArgs : CARDINAL;
     ichSelbst: TPFMain; (* Zeiger auf ADT Fenster Main *)
     meineAddr: ADDRESS; (* Addresse dazu *)
     AutoDatum, Heute: Datum.TDatum;
     MeldString, DatumString: String.TString;

(* --------------------------------------------------------------- *)

PROCEDURE AktivFMain();
  VAR
    Text       : String.TString;
    reaktProc: TProc;
    meineAddr: ADDRESS;
    ichSelbst: TPFMain;
  BEGIN
    (* Erzeuge den Fensterinhalt *)

    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFMain, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren (Meiner Meinung nach fr Hauptfenster nicht notwendig, da ohnehin
       hier eine globale Variable gesetzt ist; jedoch bei allen anderen ADT's notwendig) *)


    Text := String.Create();
    String.Schreibe(Text,"Test-Grabo zum Personalsachbeauftragten PSB");
    ichSelbst^.MeldHdle:=StelleMeldungDar(Text,TRUE,ichSelbst^.WinHdle,10,10);


    String.Schreibe(Text,"Ende");
    ichSelbst^.EndeKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,530,50,CAST(PROC,EndeKnopfCallback));

    String.Schreibe(Text,"Kostenstelle anlegen");
    ichSelbst^.FAnlegenKstKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,10,50,CAST(PROC,FAnlegenKstKnopfCallback));

    String.Schreibe(Text,"Kostenstelle bearbeiten");
    ichSelbst^.FSelektionBearbKstKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,10,75,CAST(PROC,FSelektionBearbKstKnopfCallback));

    String.Schreibe(Text,"Kostenstelle buchen");
    ichSelbst^.FSelektionBuKstKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,10,100,CAST(PROC,FSelektionBuKstKnopfCallback));

    String.Schreibe(Text,"Weihnachtsgeldkondition einfuegen");
    ichSelbst^.FKondWkEinKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,10,125,CAST(PROC,FKondWkEinKnopfCallback));

    String.Schreibe(Text,"gueltige Weihnachtsgeldkondition anzeigen");
    ichSelbst^.FKondWkAnzKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,10,150,CAST(PROC,FKondWkAnzKnopfCallback));

    String.Schreibe(Text,"Tarifkondition einfuegen");
    ichSelbst^.FKondTkEinKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,10,175,CAST(PROC,FKondTkEinKnopfCallback));

    String.Schreibe(Text,"gueltige Tarifkondition anzeigen");
    ichSelbst^.FKondTkAnzKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,10,200,CAST(PROC,FKondTkAnzKnopfCallback));

    String.Schreibe(Text,"Vetragskondition einfuegen");
    ichSelbst^.FKondVtrEinKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,10,225,CAST(PROC,FKondVtrEinKnopfCallback));

    String.Schreibe(Text,"gueltige Vertragskondition anzeigen");
    ichSelbst^.FKondVtrAnzKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,10,250,CAST(PROC,FKondVtrAnzKnopfCallback));

    String.Schreibe(Text,"Inforetrieval");
ichSelbst^.FInfoKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,400,230+60,CAST(PROC,FInfoKnopfCallback));

    String.Schreibe(Text,"Auto-Datum aendern");
ichSelbst^.FAutoDatEinKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,400,275+60,CAST(PROC,FAutoDatEinKnopfCallback));

    String.Schreibe(Text,"System-Datum aendern");
ichSelbst^.FSysDatEinKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,400,300+60,CAST(PROC,FSysDatEinKnopfCallback));

    String.Schreibe(Text,"Backup");
ichSelbst^.BackupKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,400,325+60,CAST(PROC,BackupKnopfCallback));

    String.Schreibe(Text,"System - Variablen");
ichSelbst^.FSysVarAnzKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,400,350+60,CAST(PROC,FSysVarAnzKnopfCallback));

    String.Schreibe(Text,"Restore");
ichSelbst^.FSelResVerKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,400,375+60,CAST(PROC,FSelResVerKnopfCallback));


    String.Schreibe(Text,"Listboxchen");
ichSelbst^.FListBoxKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,400,400+60,CAST(PROC,FListBoxKnopfCallback));



    String.Schreibe(Text,"HK anlegen");
    ichSelbst^.FAnlegenHKKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,400,50,CAST(PROC,FAnlegenHKKopfCallback));

    String.Schreibe(Text,"HK bearbeiten");
    ichSelbst^.FSelektionHKKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,400,75,CAST(PROC,FSelektionHKKnopfCallback));


    String.Schreibe(Text,"Vtr anlegen");
    ichSelbst^.FAnlegenVtrHKBKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,400,100,CAST(PROC,FAnlegenVtrHKBKopfCallback));

    String.Schreibe(Text,"Vtr bearbeiten");
    ichSelbst^.FAendernVtrHKBKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,400,125,CAST(PROC,FAendernVtrHKBKnopfCallback));

    String.Schreibe(Text,"Autom. Betrieb");
    ichSelbst^.AutoBetriebKnopfHdle:=StelleKnopfDar(Text,ichSelbst^.WinHdle,400,150,CAST(PROC,AutoBetriebKnopfCallback));

    String.Dispose(Text);

  END AktivFMain;


PROCEDURE EndeKnopfCallback();
  BEGIN
    DisposeFMain();
  END EndeKnopfCallback;

PROCEDURE FAnlegenKstKnopfCallback();
  BEGIN
    DeaktFMain();
    FAnlegenKst.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FAnlegenKstKnopfCallback;

PROCEDURE FSelektionBuKstKnopfCallback();
  BEGIN
    DeaktFMain();
    FSelBuKst.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FSelektionBuKstKnopfCallback;


PROCEDURE FSelektionBearbKstKnopfCallback();
  BEGIN
    DeaktFMain();
    FSelBeaKst.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FSelektionBearbKstKnopfCallback;

PROCEDURE FKondWkEinKnopfCallback();
  BEGIN
    DeaktFMain();
    FKondWkEin.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FKondWkEinKnopfCallback;

PROCEDURE FKondWkAnzKnopfCallback();
  BEGIN
    DeaktFMain();
    FKondWkAnz.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FKondWkAnzKnopfCallback;

PROCEDURE FKondTkEinKnopfCallback();
  BEGIN
    DeaktFMain();
    FKondTkEin.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FKondTkEinKnopfCallback;

PROCEDURE FKondVtrEinKnopfCallback();
  BEGIN
    DeaktFMain();
    FKondVtrEin.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FKondVtrEinKnopfCallback;

PROCEDURE FKondTkAnzKnopfCallback();
  BEGIN
    DeaktFMain();
    FKondTkAnz.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FKondTkAnzKnopfCallback;

PROCEDURE FKondVtrAnzKnopfCallback();
  BEGIN
    DeaktFMain();
    FKondVtrAnz.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FKondVtrAnzKnopfCallback;


PROCEDURE FListBoxKnopfCallback();
  CONST
      FHoehe=INT(300);
      FBreite=INT(500);
  VAR
    FUeb, LBUeb     : String.TString;
    Text     : String.TString;
    Listenelement: String.TString;
    StringListe: Stringliste.TStringliste;
    I:INTEGER;
  BEGIN
    DeaktFMain();


    StringListe := Stringliste.Create();

    FUeb := String.Create();
    String.Schreibe (FUeb,"      F e n s t e r    Ueberschrift ");

    LBUeb := String.Create();
    String.Schreibe (LBUeb,"     L i s t B o x      Ueberschrift ");

    Listenelement := String.Create();

    String.Schreibe (Listenelement,"                   Dieses  und  Jenes  und  Ueberhaupt:");
    Stringliste.Append(StringListe,Listenelement);
    String.Schreibe (Listenelement,"");
    Stringliste.Append(StringListe,Listenelement);
    String.Schreibe (Listenelement,"                  22222222222222222222222222222222222222222222222");
    Stringliste.Append(StringListe,Listenelement);
    String.Schreibe (Listenelement,"                  33333333333333333333333333333333333333333333333");
    Stringliste.Append(StringListe,Listenelement);
    String.Schreibe (Listenelement,"                                                 Summe: 444444444");
    Stringliste.Append(StringListe,Listenelement);
    String.Schreibe (Listenelement,"");
    Stringliste.Append(StringListe,Listenelement);

    FOR I:=1 TO 200 DO
      String.Schreibe (Listenelement,"********************************************************************");
      Stringliste.Append(StringListe,Listenelement);
    END;

    String.Dispose(Listenelement);


    FListBox.CreateFAnlegen(FUeb, LBUeb, FUeb, LBUeb, StringListe);
    (* Neues Fenster erzeugen *)

    String.Dispose(FUeb);
    String.Dispose(LBUeb);

    (* bereinigen *)
    WHILE NOT (Stringliste.IsEmpty(StringListe)) DO
      Stringliste.GoStart(StringListe);
      Stringliste.Delete(StringListe);
    END;
    Stringliste.Dispose(StringListe);


  END FListBoxKnopfCallback;



PROCEDURE FSysDatEinKnopfCallback();
  BEGIN
    DeaktFMain();
    FSysDatEin.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FSysDatEinKnopfCallback;


PROCEDURE FAutoDatEinKnopfCallback();
  BEGIN
    DeaktFMain();
    FAutDatEin.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FAutoDatEinKnopfCallback;


PROCEDURE BackupKnopfCallback();
  VAR
    Text, Inhalt: String.TString;
    ZWDatumString, GueltigabString, GueltigbisString, MeldString,
    					StundensatzString: String.TString;
    ZWDatumStr, GueltigabStr, GueltigbisStr, TextStr, MeldStr, StundensatzStr: ARRAY[1..200] OF CHAR;
  BEGIN

   IF Adm.BackupSystemInAdm(MeldString) THEN
      MeldStr:="Backup war erfolgreich!";
      AusgebenMeldung(MeldStr);
   ELSE
      String.Lies(MeldString, MeldStr);
      AusgebenMeldung(MeldStr);
    END;

  END BackupKnopfCallback;


PROCEDURE FSysVarAnzKnopfCallback();
  BEGIN
    DeaktFMain();
    FSysVarAnz.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FSysVarAnzKnopfCallback;


PROCEDURE FSelResVerKnopfCallback();
  BEGIN
    DeaktFMain();
    FSelResVer.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FSelResVerKnopfCallback;

PROCEDURE FInfoKnopfCallback();
  BEGIN
    DeaktFMain();
    FInfo.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FInfoKnopfCallback;








PROCEDURE FAnlegenHKKopfCallback();
  BEGIN
    DeaktFMain();
    FAnlegenHK.CreateFAnlegen();
    (* Neues Fenster erzeugen *)
  END FAnlegenHKKopfCallback;

PROCEDURE FSelektionHKKnopfCallback();
  BEGIN
    DeaktFMain();
    FSelektionHK.CreateFSelektion();
    (* Neues Fenster erzeugen *)
  END FSelektionHKKnopfCallback;




PROCEDURE FAnlegenVtrHKBKopfCallback();
  BEGIN
    DeaktFMain();
    FAnlegenVtrHKB.Create(CAST(ADDRESS,ReaktFMain));
    (* Neues Fenster erzeugen *)
  END FAnlegenVtrHKBKopfCallback;


PROCEDURE FAendernVtrHKBKnopfCallback();
  BEGIN
    DeaktFMain();
    FAendernVtrHKB.Create(CAST(ADDRESS,ReaktFMain));
    (* Neues Fenster erzeugen *)
  END FAendernVtrHKBKnopfCallback;


PROCEDURE AutoBetriebKnopfCallback();
  VAR
    ZWDatumStr, GueltigabStr, GueltigbisStr, TextStr, MeldStr, StundensatzStr: ARRAY[1..200] OF CHAR;
  starr : ARRAY [0..200] OF CHAR;
  BEGIN
    AutoDatum:=SysDat.LiesLetztesAutoDatumInSysDat();
    Heute:=SysDat.LiesSystemDatumInSysDat();
    WriteString("vor Auto Betrieb"); WriteLn;
    Auto.NachziehenAutoBuen(AutoDatum, Heute);
    WriteString("nach Auto Betrieb"); WriteLn;
String.Lies (Datum.DatumAlsString(AutoDatum), starr);
WriteString (starr);
WriteLn;
String.Lies (Datum.DatumAlsString(Heute), starr);
WriteString (starr);
WriteLn;


    SysDat.SetzeLetztesAutoDatumInSysDat(AutoDatum);
    WriteString("nach LetztesAutoDatum in SysDat setzten"); WriteLn;
    MeldStr:="Der automatische Betrieb wurde durchgefhrt!";
    AusgebenMeldung(MeldStr);
 END AutoBetriebKnopfCallback;




PROCEDURE DisposeFMain();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFMain;
  BEGIN
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFMain, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADO Fenster generieren *)

    EntferneFenster(ichSelbst^.WinHdle);
    Pop();
    (* Lschen des letzten Stapeleintrages *)
  END DisposeFMain;

PROCEDURE DeaktFMain();
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFMain;
  BEGIN
    IF TRACE THEN WriteString("mainjz.DeaktFMain Begin"); WriteLn; END;
    (*Deaktiviere Knpfe, Listboxen,... *)
    Top(reaktProc, meineAddr);
    ichSelbst:= CAST(TPFMain, meineAddr);
    (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren (Meiner Meinung nach fr Hauptfenster nicht notwendig, da ohnehin
       hier eine globale Variable gesetzt ist; jedoch bei allen anderen ADT's notwendig) *)

    SetzeKnopf(ichSelbst^.EndeKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FAnlegenKstKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FSelektionBuKstKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FSelektionBearbKstKnopfHdle, FALSE);

(*  SetzeKnopf(ichSelbst^.FSelektionBearbKstTKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FSelektionBuKstTKnopfHdle, FALSE);   *)

    SetzeKnopf(ichSelbst^.FKondWkEinKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FKondTkEinKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FKondVtrEinKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FKondWkAnzKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FKondTkAnzKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FKondVtrAnzKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FListBoxKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FSysDatEinKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.BackupKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FSelResVerKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FSysVarAnzKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FInfoKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FAnlegenHKKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FSelektionHKKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FAnlegenVtrHKBKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FAendernVtrHKBKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.AutoBetriebKnopfHdle, FALSE);
    SetzeKnopf(ichSelbst^.FAutoDatEinKnopfHdle, FALSE);
    			

  (* Elemente deaktivieren *)


    IF TRACE THEN WriteString("mainjz.DeaktFMain End"); WriteLn; END;
  END DeaktFMain;

PROCEDURE ReaktFMain();                                                           		
  VAR meineAddr: ADDRESS;
      reaktProc: TProc;
      ichSelbst: TPFMain;
  BEGIN
    IF TRACE THEN WriteString("mainjz.RaktFMain Begin"); WriteLn; END;
   (* Aktiviere alle Fensterinhalte *)
   Top(reaktProc, meineAddr);
   ichSelbst:= CAST(TPFMain, meineAddr);
   (* Aktuellen Stapeleintrag holen, und Zeiger auf ADT Fenster generieren *)

    SetzeKnopf(ichSelbst^.EndeKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FAnlegenKstKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FSelektionBuKstKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FSelektionBearbKstKnopfHdle, TRUE);

(*  SetzeKnopf(ichSelbst^.FSelektionBearbKstTKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FSelektionBuKstTKnopfHdle, TRUE);    *)

    SetzeKnopf(ichSelbst^.FKondWkEinKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FKondTkEinKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FKondVtrEinKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FKondWkAnzKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FKondTkAnzKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FKondVtrAnzKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FListBoxKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FSysDatEinKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FSysVarAnzKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.BackupKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FSelResVerKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FSysVarAnzKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FInfoKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FAnlegenHKKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FSelektionHKKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FAnlegenVtrHKBKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FAendernVtrHKBKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.AutoBetriebKnopfHdle, TRUE);
    SetzeKnopf(ichSelbst^.FAutoDatEinKnopfHdle, TRUE);
    			

   (* Elemente aktivieren *)
   IF TRACE THEN WriteString("mainjz.RaktFMain End"); WriteLn; END;
  END ReaktFMain;




PROCEDURE AusgebenMeldung(inStr:ARRAY OF CHAR);
   VAR
    MeldText: String.TString;
  BEGIN
    IF TRACE THEN WriteString("FKondTkAnz.AusgebenMeldung Begin"); WriteLn; END;
    MeldText := String.Create();
    String.Schreibe(MeldText, inStr);
    MeldungAnzeigen(MeldText);
    String.Dispose(MeldText);
    IF TRACE THEN WriteString("FKondTkAnz.AusgebenMeldung End"); WriteLn; END;
  END AusgebenMeldung;





CONST
  TRACE=FALSE;
BEGIN

  GetArgs (AnzArgs,Args);
  HauptfensterHdle := InitialisiereGrafik(AnzArgs,Args,10,10,500,600);
  (* Addresse des Fensterrahmens bestimmen *)


  Heute:=Datum.CreateDatum();
  DatumString:=String.Create();
  String.Schreibe(DatumString,"25.2.2001");
  IF Datum.DatumVonString(DatumString, Heute, MeldString) THEN
    SysDat.SetzeSystemDatumInSysDat(Heute);
  END;


  NEW (ichSelbst);
  (* Speicherplatz fr den "ADT Fenster Main" reservieren *)
  meineAddr:= CAST(ADDRESS, ichSelbst);
  (* Zeiger auf die Addresse des "ADT Fenster Main" bestimmen *)
  Push(ReaktFMain, meineAddr);
  (* Reaktivierungsprozedur des "ADT Fenster Main" und dessen Addresszeiger auf Stapel legen *)

  ichSelbst^.WinHdle:= HauptfensterHdle;
  (* Addresszeiger des Fensterrahmens im "ADT Fenster Main" eintragen *)

  AktivFMain();
  (* Prozedure zum Aufbauen des Fensterinhaltes aufrufen *)

  StarteGrafik();
END mainpsb.
