 (* Fernuni Hagen, Sopra WS2000/01     Christian Sonnweber  *)

MODULE hiks;

FROM   ProgArgs IMPORT  GetArg;
FROM   Types    IMPORT  SHORTCARD,LONGCARD;
FROM   args     IMPORT  GetArgs, ArgTable;
FROM   SYSTEM   IMPORT  CAST, ADR, ADDRESS;
FROM   X_Grafik IMPORT  StelleListeDar,EntferneListe;
FROM   X_Grafik IMPORT  LiesListenelement, AendereListenelement;
FROM   X_Grafik IMPORT  StelleZeileDar, LiesZeile, EntferneZeile, SetzeZeile;
FROM   X_Grafik IMPORT  StelleTextDar, EntferneText;
FROM   X_Grafik IMPORT  StelleMeldungDar, EntferneMeldung;
FROM   X_Grafik IMPORT  InitialisiereGrafik, StarteGrafik;
FROM   X_Grafik IMPORT  NeuesFenster, EntferneFenster;
FROM   X_Grafik IMPORT  MeldungAnzeigen, JaNeinAbfrage;
FROM   X_Grafik IMPORT  StringEingabeFenster, StringEingabeAuslesen;
FROM   X_Grafik IMPORT  StelleMenueDar, SetzeMenueEintrag, SetzeMenue;
FROM   X_Grafik IMPORT  StelleKnopfDar, EntferneKnopf, SetzeKnopf;
FROM   X_Grafik IMPORT  LiesMenueEintrag, EntferneMenue;
FROM   InOut    IMPORT  WriteString,WriteLn,WriteInt;
FROM   SysReaktFStapel  IMPORT  Push, Pop, Top, TProc;   (*Fensterstapel fr Grabo *)

IMPORT  Strings;
IMPORT  String;
IMPORT  Stringliste;
IMPORT  Datum;
IMPORT  Vtre;
IMPORT  SysDat;
IMPORT  Ksten;
IMPORT  HKe;
IMPORT  Adm;

 (* Christian Sonnweber  *)
IMPORT  FLadenSysVw;                       (*Kind-Fenster *)
IMPORT  FSichernSysVw;                     (*Kind-Fenster *)
IMPORT  FSetDatumSysVw;                    (*Kind-Fenster *)
IMPORT  FAnlegenVtrHKB;                    (*Kind-Fenster *)
IMPORT  FAendernVtrHKB;                    (*Kind-Fenster *)

 (*  Johann Zeiser  *)
IMPORT  FAnlegenKst;                      (*Kind-Fenster *)
IMPORT  FSelBeaKst;                       (*Kind-Fenster *)
IMPORT  FSelBuKst;                        (*Kind-Fenster *)
IMPORT  FKondWkEin;                       (*Kind-Fenster *)
IMPORT  FKondWkAnz;			  (*Kind-Fenster *)
IMPORT  FKondTkEin;                       (*Kind-Fenster *)
IMPORT  FKondVtrEin;                      (*Kind-Fenster *)
IMPORT  FKondTkAnz;                       (*Kind-Fenster *)
IMPORT  FKondVtrAnz;                      (*Kind-Fenster *)
IMPORT  FInfo;				  (*Kind-Fenster *)

 (* Johannes Magauer  *)
IMPORT  FAnlegenHK;                       (*Kind-Fenster *)
IMPORT  FAendernHK;                       (*Kind-Fenster *)
IMPORT  FSelektionHK;                     (*Kind-Fenster *)



TYPE
 TCharString   =  ARRAY[0..255] OF CHAR;


VAR
  HauptFensterHandle	: ADDRESS;
  HKBMenuHandle		: ADDRESS;
  PSBMenuHandle		: ADDRESS;
  EndeKnopfHandle	: ADDRESS;
  DummyHandle		: ADDRESS;
  SysVwMenuHandle 	: ADDRESS;
  Args                  : ArgTable;	
  AnzArgs 		: CARDINAL;

(*---------------------------------------------------------------------------------------- *)

PROCEDURE ErzeugeKnoepfe(  );

VAR Titel : String.TString;

BEGIN
  Titel := String.Create(  );
  String.Schreibe( Titel,"Ende" );
  EndeKnopfHandle := StelleKnopfDar( Titel,HauptFensterHandle,10,10,CAST( PROC,EndeKnopfCallback ) );

END ErzeugeKnoepfe;

 (*---------------------------------------------------------------------------------------- *)

PROCEDURE EndeKnopfCallback(  );

VAR 	Abfragetext 	: String.TString;
	mesg		: String.TString;
BEGIN
  Abfragetext := String.Create(  );
  String.Schreibe( Abfragetext,"Wirklich beenden?" );
  IF JaNeinAbfrage( Abfragetext )
  THEN
    IF NOT Adm.WriteIniDatei( mesg ) THEN
	MeldungAnzeigen( mesg );
	String.Dispose( mesg );
    END  (* IF  *);
    EntferneKnopf( EndeKnopfHandle );
    EntferneFenster( HauptFensterHandle );
  END;

END EndeKnopfCallback;

 (*---------------------------------------------------------------------------------------- *)

PROCEDURE SysVwMenuErstellen(  );

VAR
    MenuStringliste    : Stringliste.TStringliste;
    ErsterMenuEintrag,
    ZweiterMenuEintrag,
    DritterMenuEintrag,
    Ueberschrift       : String.TString;

BEGIN
    MenuStringliste    := Stringliste.Create(  );
    ErsterMenuEintrag:= String.Create(  );
    String.Schreibe ( ErsterMenuEintrag,"Datum Eingeben" );
    Stringliste.Append( MenuStringliste,ErsterMenuEintrag );

    ZweiterMenuEintrag := String.Create(  );
    String.Schreibe ( ZweiterMenuEintrag,"System Laden" );
    Stringliste.Append( MenuStringliste,ZweiterMenuEintrag );

    DritterMenuEintrag := String.Create(  );
    String.Schreibe ( DritterMenuEintrag,"System Sichern" );
    Stringliste.Append( MenuStringliste,DritterMenuEintrag );

    Ueberschrift       := String.Create(  );
    String.Schreibe( Ueberschrift,"Systemverwaltung" );
    SysVwMenuHandle    := StelleMenueDar( MenuStringliste,Ueberschrift,
                       HauptFensterHandle,100,10,CAST( PROC,SysVwMenuCallback ) );

    SetzeMenue( SysVwMenuHandle,TRUE );

END SysVwMenuErstellen;

 (*---------------------------------------------------------------------------------------- *)


PROCEDURE SysVwMenuCallback ( number : INTEGER );

  VAR
    Laenge               : INTEGER;
    NeuesElement,
    FensterUeberschrift,
    Loeschtext           : String.TString;

  BEGIN
    CASE number OF
           1 : DeActivate(  );
               FSetDatumSysVw.Create( CAST( ADDRESS,Activate ) );


         | 2 : DeActivate(  );
               FLadenSysVw.Create( CAST( ADDRESS,Activate ) );

         | 3 : DeActivate(  );
               FSichernSysVw.Create( CAST( ADDRESS,Activate ) );
   END

END SysVwMenuCallback;

 (* ----------------------------------------------------------------------------------  *)

PROCEDURE HKBMenuCallback ( number : INTEGER );

  VAR
    Laenge               : INTEGER;
    NeuesElement,
    FensterUeberschrift,
    Loeschtext           : String.TString;

  BEGIN
    CASE number OF
          1 :  DeActivate(  );
               Push( Activate,NIL );
               FAnlegenHK.CreateFAnlegen(  );

         | 2 : DeActivate(  );
               Push( Activate,NIL );
               FSelektionHK.CreateFSelektion(  );

         | 3 :

         | 4 : DeActivate(  );
               FAnlegenVtrHKB.Create( CAST( ADDRESS,Activate) );


         | 5 : DeActivate(  );
               FAendernVtrHKB.Create( CAST( ADDRESS,Activate ) );

          (* Eingefgt von Magauer  *)
         | 6 :

         | 7 : DeActivate(  );
               Push( Activate,NIL );
               FInfo.CreateFAnlegen(  );
          (* Ende Einfgung  *)

    END

END HKBMenuCallback;
 (*------------------------------------------------------------------------------------- *)



PROCEDURE PSBMenuCallback ( number : INTEGER );

  VAR
    Laenge               : INTEGER;
    NeuesElement,
    FensterUeberschrift,
    Loeschtext           : String.TString;

  BEGIN
    CASE number OF
          1 :  DeActivate(  );
               Push( Activate,NIL );
               FAnlegenKst.CreateFAnlegen(  );

         | 2 : DeActivate(  );
               Push( Activate,NIL );
               FSelBeaKst.CreateFAnlegen(  );

         | 3 : DeActivate(  );
               Push( Activate,NIL );
               FSelBuKst.CreateFAnlegen(  );

         | 4 :  (* Tu nichts  *)

         | 5 : DeActivate(  );
               Push( Activate,NIL );
               FKondWkEin.CreateFAnlegen(  );

         | 6 : DeActivate(  );
               Push( Activate,NIL );
               FKondWkAnz.CreateFAnlegen(  );

         | 7 : DeActivate(  );
               Push( Activate,NIL );
               FKondTkEin.CreateFAnlegen(  );

         | 8 : DeActivate(  );
               Push( Activate,NIL );
               FKondTkAnz.CreateFAnlegen(  );

         | 9 : DeActivate(  );
               Push( Activate,NIL );
               FKondVtrEin.CreateFAnlegen(  );

         | 10 : DeActivate(  );
               Push( Activate,NIL );
               FKondVtrAnz.CreateFAnlegen(  );

               (* Eingefgt von Magauer  *)
         | 11 :

         | 12 : DeActivate(  );
               Push( Activate,NIL );
               FInfo.CreateFAnlegen(  );
          (* Ende Einfgung  *)
    END

END PSBMenuCallback;

 (*----------------------------------------------------------------------------------- *)

PROCEDURE HKBMenuErstellen(  );

  VAR
    MenuStringliste    : Stringliste.TStringliste;
    MenuEintrag,

    Ueberschrift       : String.TString;

  BEGIN
    MenuStringliste := Stringliste.Create(  );
    MenuEintrag := String.Create(  );

    String.Schreibe ( MenuEintrag,"Hilfskraft anlegen" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"Hilfskraft bearbeiten" );
    Stringliste.Append( MenuStringliste,MenuEintrag );

    String.Schreibe ( MenuEintrag,"-------------------" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"Vertrag erzeugen & buchen" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe  ( MenuEintrag,"Vertrag ndern" );
    Stringliste.Append( MenuStringliste,MenuEintrag );

     (* Eingefgt von Magauer  *)
    String.Schreibe ( MenuEintrag,"-------------------" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"Info-Retrieval" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
     (* Ende Einfgung  *)

     Ueberschrift := String.Create(  );
    String.Schreibe( Ueberschrift,"Hilfskraftbeauftragter" );
    HKBMenuHandle := StelleMenueDar( MenuStringliste,Ueberschrift,
                                    HauptFensterHandle,250,10,CAST( PROC,HKBMenuCallback ) );
    SetzeMenue( SysVwMenuHandle,TRUE );

END HKBMenuErstellen;

 (*----------------------------------------------------------------------------------- *)

PROCEDURE PSBMenuErstellen(  );

  VAR
    MenuStringliste    : Stringliste.TStringliste;
    MenuEintrag,
    Ueberschrift       : String.TString;

  BEGIN
    MenuStringliste := Stringliste.Create(  );
    MenuEintrag := String.Create(  );
    String.Schreibe ( MenuEintrag,"Kostenstelle anlegen" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"Kostenstelle bearbeiten" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"Freie Buchung vornehmen" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"-----------------------------------------" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"Weihnachtsgeldkondition anlegen" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"aktuelle Weihnachtsgeldkondition anzeigen" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"Tarifkondition anlegen" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"aktuelle Tarifkondition anzeigen" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"Vertragskondition anlegen" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"aktuelle Vertragskondition anzeigen" );
    Stringliste.Append( MenuStringliste,MenuEintrag );

     (* eingefgt von Magauer  *)
    String.Schreibe ( MenuEintrag,"-----------------------------------------" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
    String.Schreibe ( MenuEintrag,"Info-Retrieval" );
    Stringliste.Append( MenuStringliste,MenuEintrag );
     (* Ende Einfgung  *)

    Ueberschrift := String.Create(  );
    String.Schreibe( Ueberschrift,"Personalsachbearbeiter" );
    PSBMenuHandle := StelleMenueDar( MenuStringliste,Ueberschrift,
                       HauptFensterHandle,420,10,CAST( PROC,PSBMenuCallback ) );

    SetzeMenue( SysVwMenuHandle,TRUE );

END PSBMenuErstellen;

 (*----------------------------------------------------------------------------------- *)

PROCEDURE DeActivate(  );

BEGIN

  SetzeMenue( SysVwMenuHandle,FALSE );
  SetzeMenue( HKBMenuHandle,FALSE );
  SetzeMenue( PSBMenuHandle,FALSE );
  (* SetzeKnopf( EndeKnopfHandle,FALSE ); *)

END DeActivate;

 (*----------------------------------------------------------------------------------- *)

PROCEDURE Activate(  );

VAR date : Datum.TDatum;

BEGIN
  (* Steuerung der Zustandsbergaenge *)
  SetzeKnopf( EndeKnopfHandle,TRUE  );
  SetzeMenue( SysVwMenuHandle,TRUE  );
  date := SysDat.LiesSystemDatumInSysDat(  );
  IF Datum.IstDatumEternity( date  ) THEN
    SetzeMenueEintrag( SysVwMenuHandle,2,FALSE  );
    SetzeMenueEintrag( SysVwMenuHandle,3,FALSE  );
    SetzeMenue( HKBMenuHandle,FALSE );
    SetzeMenue( PSBMenuHandle,FALSE );
  ELSE
    SetzeMenueEintrag( SysVwMenuHandle,2,TRUE  );

  END;
  IF ( FLadenSysVw.SystemGeladen(  ) <> FALSE ) THEN
      SetzeMenue( PSBMenuHandle,TRUE  );
      SetzeMenue( HKBMenuHandle,TRUE  );
      SetzeMenueEintrag( SysVwMenuHandle,3,TRUE  );
  END;

END Activate;

 (*----------------------------------------------------------------------------------- *)

PROCEDURE StC( inStr : String.TString  ) : TCharString;
 (*Umwandlung von TString nach ARRAY OF CHAR = TCharString *)

VAR outcharfeld : TCharString;

BEGIN

String.Lies( inStr,outcharfeld  );
 RETURN outcharfeld;

END StC;

(*----------------------------------------------------------------------------------- *)

                                               (* HAUPTPROGRAMM  *)

VAR ok 	     :  BOOLEAN;
    text     :  String.TString;
    errmsg   :  String.TString;

BEGIN

   DummyHandle:=NIL;
   GetArgs ( AnzArgs,Args  );

   IF NOT Adm.ReadIniDatei( errmsg  ) THEN
	WriteString( StC( errmsg  ) );
        String.Dispose( errmsg  );
   END; 	

   HauptFensterHandle := InitialisiereGrafik( AnzArgs,Args,0,80,50,790  );
   ErzeugeKnoepfe(  );
   SysVwMenuErstellen(  );
   HKBMenuErstellen(  );
   PSBMenuErstellen(  );
   SetzeMenueEintrag( SysVwMenuHandle,2,FALSE  );
   SetzeMenueEintrag( SysVwMenuHandle,3,FALSE  );
   SetzeMenue( HKBMenuHandle,FALSE  );
   SetzeMenue( PSBMenuHandle, FALSE  );
   StarteGrafik(  );

END hiks.
